/* A Bison parser, made by GNU Bison 3.7.5.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30705

/* Bison version string.  */
#define YYBISON_VERSION "3.7.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         ir3_yyparse
#define yylex           ir3_yylex
#define yyerror         ir3_yyerror
#define yydebug         ir3_yydebug
#define yynerrs         ir3_yynerrs
#define yylval          ir3_yylval
#define yychar          ir3_yychar

/* First part of user prologue.  */
#line 31 "../src/freedreno/ir3/ir3_parser.y"

#define YYDEBUG 0

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

#include "util/half_float.h"
#include "util/u_math.h"

#include "ir3/ir3.h"
#include "ir3/ir3_shader.h"
#include "ir3/instr-a3xx.h"

#include "ir3_parser.h"

#define swap(a, b) \
	do { __typeof(a) __tmp = (a); (a) = (b); (b) = __tmp; } while (0)

/* ir3 treats the abs/neg flags as separate flags for float vs integer,
 * but in the instruction encoding they are the same thing.  Tracking
 * them separately is only for the benefit of ir3 opt passes, and not
 * required here, so just use the float versions:
 */
#define IR3_REG_ABS     IR3_REG_FABS
#define IR3_REG_NEGATE  IR3_REG_FNEG

static struct ir3_kernel_info    *info;
static struct ir3_shader_variant *variant;
/* NOTE the assembler doesn't really use the ir3_block construction
 * like the compiler does.  Everything is treated as one large block.
 * Which might happen to contain flow control.  But since we don't
 * use any of the ir3 backend passes (sched, RA, etc) this doesn't
 * really matter.
 */
static struct ir3_block          *block;   /* current shader block */
static struct ir3_instruction    *instr;   /* current instruction */
static unsigned ip; /* current instruction pointer */
static struct hash_table *labels;

void *ir3_parser_dead_ctx;

static struct {
	unsigned flags;
	unsigned repeat;
	unsigned nop;
} iflags;

static struct {
	unsigned flags;
	unsigned wrmask;
} rflags;

int ir3_yyget_lineno(void);

static void new_label(const char *name)
{
	ralloc_steal(labels, (void *) name);
	_mesa_hash_table_insert(labels, name, (void *)(uintptr_t)ip);
}

static struct ir3_instruction * new_instr(opc_t opc)
{
	instr = ir3_instr_create(block, opc, 5);
	instr->flags = iflags.flags;
	instr->repeat = iflags.repeat;
	instr->nop = iflags.nop;
	instr->line = ir3_yyget_lineno();
	iflags.flags = iflags.repeat = iflags.nop = 0;
	ip++;
	return instr;
}

static void new_shader(void)
{
	variant->ir = ir3_create(variant->shader->compiler, variant);
	block = ir3_block_create(variant->ir);
	list_addtail(&block->node, &variant->ir->block_list);
	ip = 0;
	labels = _mesa_hash_table_create(variant, _mesa_hash_string, _mesa_key_string_equal);
	ir3_parser_dead_ctx = ralloc_context(NULL);
}

static type_t parse_type(const char **type)
{
	if (!strncmp("f16", *type, 3)) {
		*type += 3;
		return TYPE_F16;
	} else if (!strncmp("f32", *type, 3)) {
		*type += 3;
		return TYPE_F32;
	} else if (!strncmp("u16", *type, 3)) {
		*type += 3;
		return TYPE_U16;
	} else if (!strncmp("u32", *type, 3)) {
		*type += 3;
		return TYPE_U32;
	} else if (!strncmp("s16", *type, 3)) {
		*type += 3;
		return TYPE_S16;
	} else if (!strncmp("s32", *type, 3)) {
		*type += 3;
		return TYPE_S32;
	} else if (!strncmp("u8", *type, 2)) {
		*type += 2;
		return TYPE_U8;
	} else if (!strncmp("s8", *type, 2)) {
		*type += 2;
		return TYPE_S8;
	} else {
		assert(0);  /* shouldn't get here */
		return ~0;
	}
}

static struct ir3_instruction * parse_type_type(struct ir3_instruction *instr,
		const char *type_type)
{
	instr->cat1.src_type = parse_type(&type_type);
	instr->cat1.dst_type = parse_type(&type_type);
	return instr;
}

static struct ir3_register * new_reg(int num, unsigned flags)
{
	struct ir3_register *reg;
	flags |= rflags.flags;
	if (num & 0x1)
		flags |= IR3_REG_HALF;
	reg = ir3_reg_create(instr, num>>1, flags);
	reg->wrmask = MAX2(1, rflags.wrmask);
	rflags.flags = rflags.wrmask = 0;
	return reg;
}

static struct ir3_register * dummy_dst(void)
{
	return new_reg(0, 0);
}

static void fixup_cat5_s2en(void)
{
	assert(opc_cat(instr->opc) == 5);
	if (!(instr->flags & IR3_INSTR_S2EN))
		return;
	/* For various reasons (ie. mainly to make the .s2en src easier to
	 * find, given that various different cat5 tex instructions can have
	 * different # of src registers), in ir3 the samp/tex src register
	 * is first, rather than last.  So we have to detect this case and
	 * fix things up.
	 */
	struct ir3_register *s2en_src = instr->regs[instr->regs_count - 1];

	if (instr->flags & IR3_INSTR_B)
		assert(!(s2en_src->flags & IR3_REG_HALF));
	else
		assert(s2en_src->flags & IR3_REG_HALF);

	for (int i = 1; i < instr->regs_count - 1; i++) {
		instr->regs[i+1] = instr->regs[i];
	}
	instr->regs[1] = s2en_src;
}

static void add_const(unsigned reg, unsigned c0, unsigned c1, unsigned c2, unsigned c3)
{
	struct ir3_const_state *const_state = ir3_const_state(variant);
	assert((reg & 0x7) == 0);
	int idx = reg >> (1 + 2); /* low bit is half vs full, next two bits are swiz */
	if (const_state->immediates_count == const_state->immediates_size) {
		const_state->immediates = rerzalloc(const_state,
				const_state->immediates,
				__typeof__(const_state->immediates[0]),
				const_state->immediates_size,
				const_state->immediates_size + 4);
		const_state->immediates_size += 4;
	}
	const_state->immediates[idx * 4 + 0] = c0;
	const_state->immediates[idx * 4 + 1] = c1;
	const_state->immediates[idx * 4 + 2] = c2;
	const_state->immediates[idx * 4 + 3] = c3;
	const_state->immediates_count++;
}

static void add_sysval(unsigned reg, unsigned compmask, gl_system_value sysval)
{
	unsigned n = variant->inputs_count++;
	variant->inputs[n].regid = reg;
	variant->inputs[n].sysval = true;
	variant->inputs[n].slot = sysval;
	variant->inputs[n].compmask = compmask;
	variant->total_in++;
}

static bool resolve_labels(void)
{
	int instr_ip = 0;
	foreach_instr (instr, &block->instr_list) {
		if (opc_cat(instr->opc) == 0 && instr->cat0.target_label) {
			struct hash_entry *entry = _mesa_hash_table_search(labels, instr->cat0.target_label);
			if (!entry) {
				fprintf(stderr, "unknown label %s\n", instr->cat0.target_label);
				return false;
			}
			int target_ip = (uintptr_t)entry->data;
			instr->cat0.immed = target_ip - instr_ip;
		}
		instr_ip++;
	}
	return true;
}

#ifdef YYDEBUG
int yydebug;
#endif

extern int yylex(void);
void ir3_yyset_lineno(int _line_number);
void ir3_yyset_input(FILE *f);

int yyparse(void);

static void yyerror(const char *error)
{
	fprintf(stderr, "error at line %d: %s\n", ir3_yyget_lineno(), error);
}

struct ir3 * ir3_parse(struct ir3_shader_variant *v,
		struct ir3_kernel_info *k, FILE *f)
{
	ir3_yyset_lineno(1);
	ir3_yyset_input(f);
#ifdef YYDEBUG
	yydebug = 1;
#endif
	info = k;
	variant = v;
	if (yyparse() || !resolve_labels()) {
		ir3_destroy(variant->ir);
		variant->ir = NULL;
	}
	ralloc_free(labels);
	ralloc_free(ir3_parser_dead_ctx);
	return variant->ir;
}

#line 326 "src/freedreno/ir3/ir3_parser.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "ir3_parser.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_T_INT = 3,                      /* T_INT  */
  YYSYMBOL_T_HEX = 4,                      /* T_HEX  */
  YYSYMBOL_T_FLOAT = 5,                    /* T_FLOAT  */
  YYSYMBOL_T_IDENTIFIER = 6,               /* T_IDENTIFIER  */
  YYSYMBOL_T_REGISTER = 7,                 /* T_REGISTER  */
  YYSYMBOL_T_CONSTANT = 8,                 /* T_CONSTANT  */
  YYSYMBOL_T_A_LOCALSIZE = 9,              /* T_A_LOCALSIZE  */
  YYSYMBOL_T_A_CONST = 10,                 /* T_A_CONST  */
  YYSYMBOL_T_A_BUF = 11,                   /* T_A_BUF  */
  YYSYMBOL_T_A_INVOCATIONID = 12,          /* T_A_INVOCATIONID  */
  YYSYMBOL_T_A_WGID = 13,                  /* T_A_WGID  */
  YYSYMBOL_T_A_NUMWG = 14,                 /* T_A_NUMWG  */
  YYSYMBOL_T_A_BRANCHSTACK = 15,           /* T_A_BRANCHSTACK  */
  YYSYMBOL_T_A_IN = 16,                    /* T_A_IN  */
  YYSYMBOL_T_A_OUT = 17,                   /* T_A_OUT  */
  YYSYMBOL_T_A_TEX = 18,                   /* T_A_TEX  */
  YYSYMBOL_T_ABSNEG = 19,                  /* T_ABSNEG  */
  YYSYMBOL_T_NEG = 20,                     /* T_NEG  */
  YYSYMBOL_T_ABS = 21,                     /* T_ABS  */
  YYSYMBOL_T_R = 22,                       /* T_R  */
  YYSYMBOL_T_HR = 23,                      /* T_HR  */
  YYSYMBOL_T_HC = 24,                      /* T_HC  */
  YYSYMBOL_T_EVEN = 25,                    /* T_EVEN  */
  YYSYMBOL_T_POS_INFINITY = 26,            /* T_POS_INFINITY  */
  YYSYMBOL_T_EI = 27,                      /* T_EI  */
  YYSYMBOL_T_WRMASK = 28,                  /* T_WRMASK  */
  YYSYMBOL_T_FLUT_0_0 = 29,                /* T_FLUT_0_0  */
  YYSYMBOL_T_FLUT_0_5 = 30,                /* T_FLUT_0_5  */
  YYSYMBOL_T_FLUT_1_0 = 31,                /* T_FLUT_1_0  */
  YYSYMBOL_T_FLUT_2_0 = 32,                /* T_FLUT_2_0  */
  YYSYMBOL_T_FLUT_E = 33,                  /* T_FLUT_E  */
  YYSYMBOL_T_FLUT_PI = 34,                 /* T_FLUT_PI  */
  YYSYMBOL_T_FLUT_INV_PI = 35,             /* T_FLUT_INV_PI  */
  YYSYMBOL_T_FLUT_INV_LOG2_E = 36,         /* T_FLUT_INV_LOG2_E  */
  YYSYMBOL_T_FLUT_LOG2_E = 37,             /* T_FLUT_LOG2_E  */
  YYSYMBOL_T_FLUT_INV_LOG2_10 = 38,        /* T_FLUT_INV_LOG2_10  */
  YYSYMBOL_T_FLUT_LOG2_10 = 39,            /* T_FLUT_LOG2_10  */
  YYSYMBOL_T_FLUT_4_0 = 40,                /* T_FLUT_4_0  */
  YYSYMBOL_T_SY = 41,                      /* T_SY  */
  YYSYMBOL_T_SS = 42,                      /* T_SS  */
  YYSYMBOL_T_JP = 43,                      /* T_JP  */
  YYSYMBOL_T_SAT = 44,                     /* T_SAT  */
  YYSYMBOL_T_RPT = 45,                     /* T_RPT  */
  YYSYMBOL_T_UL = 46,                      /* T_UL  */
  YYSYMBOL_T_NOP = 47,                     /* T_NOP  */
  YYSYMBOL_T_OP_NOP = 48,                  /* T_OP_NOP  */
  YYSYMBOL_T_OP_BR = 49,                   /* T_OP_BR  */
  YYSYMBOL_T_OP_BRAO = 50,                 /* T_OP_BRAO  */
  YYSYMBOL_T_OP_BRAA = 51,                 /* T_OP_BRAA  */
  YYSYMBOL_T_OP_BRAC = 52,                 /* T_OP_BRAC  */
  YYSYMBOL_T_OP_BANY = 53,                 /* T_OP_BANY  */
  YYSYMBOL_T_OP_BALL = 54,                 /* T_OP_BALL  */
  YYSYMBOL_T_OP_BRAX = 55,                 /* T_OP_BRAX  */
  YYSYMBOL_T_OP_JUMP = 56,                 /* T_OP_JUMP  */
  YYSYMBOL_T_OP_CALL = 57,                 /* T_OP_CALL  */
  YYSYMBOL_T_OP_RET = 58,                  /* T_OP_RET  */
  YYSYMBOL_T_OP_KILL = 59,                 /* T_OP_KILL  */
  YYSYMBOL_T_OP_END = 60,                  /* T_OP_END  */
  YYSYMBOL_T_OP_EMIT = 61,                 /* T_OP_EMIT  */
  YYSYMBOL_T_OP_CUT = 62,                  /* T_OP_CUT  */
  YYSYMBOL_T_OP_CHMASK = 63,               /* T_OP_CHMASK  */
  YYSYMBOL_T_OP_CHSH = 64,                 /* T_OP_CHSH  */
  YYSYMBOL_T_OP_FLOW_REV = 65,             /* T_OP_FLOW_REV  */
  YYSYMBOL_T_OP_BKT = 66,                  /* T_OP_BKT  */
  YYSYMBOL_T_OP_STKS = 67,                 /* T_OP_STKS  */
  YYSYMBOL_T_OP_STKR = 68,                 /* T_OP_STKR  */
  YYSYMBOL_T_OP_XSET = 69,                 /* T_OP_XSET  */
  YYSYMBOL_T_OP_XCLR = 70,                 /* T_OP_XCLR  */
  YYSYMBOL_T_OP_GETONE = 71,               /* T_OP_GETONE  */
  YYSYMBOL_T_OP_DBG = 72,                  /* T_OP_DBG  */
  YYSYMBOL_T_OP_SHPS = 73,                 /* T_OP_SHPS  */
  YYSYMBOL_T_OP_SHPE = 74,                 /* T_OP_SHPE  */
  YYSYMBOL_T_OP_PREDT = 75,                /* T_OP_PREDT  */
  YYSYMBOL_T_OP_PREDF = 76,                /* T_OP_PREDF  */
  YYSYMBOL_T_OP_PREDE = 77,                /* T_OP_PREDE  */
  YYSYMBOL_T_OP_MOVMSK = 78,               /* T_OP_MOVMSK  */
  YYSYMBOL_T_OP_MOVA1 = 79,                /* T_OP_MOVA1  */
  YYSYMBOL_T_OP_MOVA = 80,                 /* T_OP_MOVA  */
  YYSYMBOL_T_OP_MOV = 81,                  /* T_OP_MOV  */
  YYSYMBOL_T_OP_COV = 82,                  /* T_OP_COV  */
  YYSYMBOL_T_OP_ADD_F = 83,                /* T_OP_ADD_F  */
  YYSYMBOL_T_OP_MIN_F = 84,                /* T_OP_MIN_F  */
  YYSYMBOL_T_OP_MAX_F = 85,                /* T_OP_MAX_F  */
  YYSYMBOL_T_OP_MUL_F = 86,                /* T_OP_MUL_F  */
  YYSYMBOL_T_OP_SIGN_F = 87,               /* T_OP_SIGN_F  */
  YYSYMBOL_T_OP_CMPS_F = 88,               /* T_OP_CMPS_F  */
  YYSYMBOL_T_OP_ABSNEG_F = 89,             /* T_OP_ABSNEG_F  */
  YYSYMBOL_T_OP_CMPV_F = 90,               /* T_OP_CMPV_F  */
  YYSYMBOL_T_OP_FLOOR_F = 91,              /* T_OP_FLOOR_F  */
  YYSYMBOL_T_OP_CEIL_F = 92,               /* T_OP_CEIL_F  */
  YYSYMBOL_T_OP_RNDNE_F = 93,              /* T_OP_RNDNE_F  */
  YYSYMBOL_T_OP_RNDAZ_F = 94,              /* T_OP_RNDAZ_F  */
  YYSYMBOL_T_OP_TRUNC_F = 95,              /* T_OP_TRUNC_F  */
  YYSYMBOL_T_OP_ADD_U = 96,                /* T_OP_ADD_U  */
  YYSYMBOL_T_OP_ADD_S = 97,                /* T_OP_ADD_S  */
  YYSYMBOL_T_OP_SUB_U = 98,                /* T_OP_SUB_U  */
  YYSYMBOL_T_OP_SUB_S = 99,                /* T_OP_SUB_S  */
  YYSYMBOL_T_OP_CMPS_U = 100,              /* T_OP_CMPS_U  */
  YYSYMBOL_T_OP_CMPS_S = 101,              /* T_OP_CMPS_S  */
  YYSYMBOL_T_OP_MIN_U = 102,               /* T_OP_MIN_U  */
  YYSYMBOL_T_OP_MIN_S = 103,               /* T_OP_MIN_S  */
  YYSYMBOL_T_OP_MAX_U = 104,               /* T_OP_MAX_U  */
  YYSYMBOL_T_OP_MAX_S = 105,               /* T_OP_MAX_S  */
  YYSYMBOL_T_OP_ABSNEG_S = 106,            /* T_OP_ABSNEG_S  */
  YYSYMBOL_T_OP_AND_B = 107,               /* T_OP_AND_B  */
  YYSYMBOL_T_OP_OR_B = 108,                /* T_OP_OR_B  */
  YYSYMBOL_T_OP_NOT_B = 109,               /* T_OP_NOT_B  */
  YYSYMBOL_T_OP_XOR_B = 110,               /* T_OP_XOR_B  */
  YYSYMBOL_T_OP_CMPV_U = 111,              /* T_OP_CMPV_U  */
  YYSYMBOL_T_OP_CMPV_S = 112,              /* T_OP_CMPV_S  */
  YYSYMBOL_T_OP_MUL_U24 = 113,             /* T_OP_MUL_U24  */
  YYSYMBOL_T_OP_MUL_S24 = 114,             /* T_OP_MUL_S24  */
  YYSYMBOL_T_OP_MULL_U = 115,              /* T_OP_MULL_U  */
  YYSYMBOL_T_OP_BFREV_B = 116,             /* T_OP_BFREV_B  */
  YYSYMBOL_T_OP_CLZ_S = 117,               /* T_OP_CLZ_S  */
  YYSYMBOL_T_OP_CLZ_B = 118,               /* T_OP_CLZ_B  */
  YYSYMBOL_T_OP_SHL_B = 119,               /* T_OP_SHL_B  */
  YYSYMBOL_T_OP_SHR_B = 120,               /* T_OP_SHR_B  */
  YYSYMBOL_T_OP_ASHR_B = 121,              /* T_OP_ASHR_B  */
  YYSYMBOL_T_OP_BARY_F = 122,              /* T_OP_BARY_F  */
  YYSYMBOL_T_OP_MGEN_B = 123,              /* T_OP_MGEN_B  */
  YYSYMBOL_T_OP_GETBIT_B = 124,            /* T_OP_GETBIT_B  */
  YYSYMBOL_T_OP_SETRM = 125,               /* T_OP_SETRM  */
  YYSYMBOL_T_OP_CBITS_B = 126,             /* T_OP_CBITS_B  */
  YYSYMBOL_T_OP_SHB = 127,                 /* T_OP_SHB  */
  YYSYMBOL_T_OP_MSAD = 128,                /* T_OP_MSAD  */
  YYSYMBOL_T_OP_MAD_U16 = 129,             /* T_OP_MAD_U16  */
  YYSYMBOL_T_OP_MADSH_U16 = 130,           /* T_OP_MADSH_U16  */
  YYSYMBOL_T_OP_MAD_S16 = 131,             /* T_OP_MAD_S16  */
  YYSYMBOL_T_OP_MADSH_M16 = 132,           /* T_OP_MADSH_M16  */
  YYSYMBOL_T_OP_MAD_U24 = 133,             /* T_OP_MAD_U24  */
  YYSYMBOL_T_OP_MAD_S24 = 134,             /* T_OP_MAD_S24  */
  YYSYMBOL_T_OP_MAD_F16 = 135,             /* T_OP_MAD_F16  */
  YYSYMBOL_T_OP_MAD_F32 = 136,             /* T_OP_MAD_F32  */
  YYSYMBOL_T_OP_SEL_B16 = 137,             /* T_OP_SEL_B16  */
  YYSYMBOL_T_OP_SEL_B32 = 138,             /* T_OP_SEL_B32  */
  YYSYMBOL_T_OP_SEL_S16 = 139,             /* T_OP_SEL_S16  */
  YYSYMBOL_T_OP_SEL_S32 = 140,             /* T_OP_SEL_S32  */
  YYSYMBOL_T_OP_SEL_F16 = 141,             /* T_OP_SEL_F16  */
  YYSYMBOL_T_OP_SEL_F32 = 142,             /* T_OP_SEL_F32  */
  YYSYMBOL_T_OP_SAD_S16 = 143,             /* T_OP_SAD_S16  */
  YYSYMBOL_T_OP_SAD_S32 = 144,             /* T_OP_SAD_S32  */
  YYSYMBOL_T_OP_RCP = 145,                 /* T_OP_RCP  */
  YYSYMBOL_T_OP_RSQ = 146,                 /* T_OP_RSQ  */
  YYSYMBOL_T_OP_LOG2 = 147,                /* T_OP_LOG2  */
  YYSYMBOL_T_OP_EXP2 = 148,                /* T_OP_EXP2  */
  YYSYMBOL_T_OP_SIN = 149,                 /* T_OP_SIN  */
  YYSYMBOL_T_OP_COS = 150,                 /* T_OP_COS  */
  YYSYMBOL_T_OP_SQRT = 151,                /* T_OP_SQRT  */
  YYSYMBOL_T_OP_HRSQ = 152,                /* T_OP_HRSQ  */
  YYSYMBOL_T_OP_HLOG2 = 153,               /* T_OP_HLOG2  */
  YYSYMBOL_T_OP_HEXP2 = 154,               /* T_OP_HEXP2  */
  YYSYMBOL_T_OP_ISAM = 155,                /* T_OP_ISAM  */
  YYSYMBOL_T_OP_ISAML = 156,               /* T_OP_ISAML  */
  YYSYMBOL_T_OP_ISAMM = 157,               /* T_OP_ISAMM  */
  YYSYMBOL_T_OP_SAM = 158,                 /* T_OP_SAM  */
  YYSYMBOL_T_OP_SAMB = 159,                /* T_OP_SAMB  */
  YYSYMBOL_T_OP_SAML = 160,                /* T_OP_SAML  */
  YYSYMBOL_T_OP_SAMGQ = 161,               /* T_OP_SAMGQ  */
  YYSYMBOL_T_OP_GETLOD = 162,              /* T_OP_GETLOD  */
  YYSYMBOL_T_OP_CONV = 163,                /* T_OP_CONV  */
  YYSYMBOL_T_OP_CONVM = 164,               /* T_OP_CONVM  */
  YYSYMBOL_T_OP_GETSIZE = 165,             /* T_OP_GETSIZE  */
  YYSYMBOL_T_OP_GETBUF = 166,              /* T_OP_GETBUF  */
  YYSYMBOL_T_OP_GETPOS = 167,              /* T_OP_GETPOS  */
  YYSYMBOL_T_OP_GETINFO = 168,             /* T_OP_GETINFO  */
  YYSYMBOL_T_OP_DSX = 169,                 /* T_OP_DSX  */
  YYSYMBOL_T_OP_DSY = 170,                 /* T_OP_DSY  */
  YYSYMBOL_T_OP_GATHER4R = 171,            /* T_OP_GATHER4R  */
  YYSYMBOL_T_OP_GATHER4G = 172,            /* T_OP_GATHER4G  */
  YYSYMBOL_T_OP_GATHER4B = 173,            /* T_OP_GATHER4B  */
  YYSYMBOL_T_OP_GATHER4A = 174,            /* T_OP_GATHER4A  */
  YYSYMBOL_T_OP_SAMGP0 = 175,              /* T_OP_SAMGP0  */
  YYSYMBOL_T_OP_SAMGP1 = 176,              /* T_OP_SAMGP1  */
  YYSYMBOL_T_OP_SAMGP2 = 177,              /* T_OP_SAMGP2  */
  YYSYMBOL_T_OP_SAMGP3 = 178,              /* T_OP_SAMGP3  */
  YYSYMBOL_T_OP_DSXPP_1 = 179,             /* T_OP_DSXPP_1  */
  YYSYMBOL_T_OP_DSYPP_1 = 180,             /* T_OP_DSYPP_1  */
  YYSYMBOL_T_OP_RGETPOS = 181,             /* T_OP_RGETPOS  */
  YYSYMBOL_T_OP_RGETINFO = 182,            /* T_OP_RGETINFO  */
  YYSYMBOL_T_OP_LDG = 183,                 /* T_OP_LDG  */
  YYSYMBOL_T_OP_LDL = 184,                 /* T_OP_LDL  */
  YYSYMBOL_T_OP_LDP = 185,                 /* T_OP_LDP  */
  YYSYMBOL_T_OP_STG = 186,                 /* T_OP_STG  */
  YYSYMBOL_T_OP_STL = 187,                 /* T_OP_STL  */
  YYSYMBOL_T_OP_STP = 188,                 /* T_OP_STP  */
  YYSYMBOL_T_OP_LDIB = 189,                /* T_OP_LDIB  */
  YYSYMBOL_T_OP_G2L = 190,                 /* T_OP_G2L  */
  YYSYMBOL_T_OP_L2G = 191,                 /* T_OP_L2G  */
  YYSYMBOL_T_OP_PREFETCH = 192,            /* T_OP_PREFETCH  */
  YYSYMBOL_T_OP_LDLW = 193,                /* T_OP_LDLW  */
  YYSYMBOL_T_OP_STLW = 194,                /* T_OP_STLW  */
  YYSYMBOL_T_OP_RESFMT = 195,              /* T_OP_RESFMT  */
  YYSYMBOL_T_OP_RESINFO = 196,             /* T_OP_RESINFO  */
  YYSYMBOL_T_OP_ATOMIC_ADD = 197,          /* T_OP_ATOMIC_ADD  */
  YYSYMBOL_T_OP_ATOMIC_SUB = 198,          /* T_OP_ATOMIC_SUB  */
  YYSYMBOL_T_OP_ATOMIC_XCHG = 199,         /* T_OP_ATOMIC_XCHG  */
  YYSYMBOL_T_OP_ATOMIC_INC = 200,          /* T_OP_ATOMIC_INC  */
  YYSYMBOL_T_OP_ATOMIC_DEC = 201,          /* T_OP_ATOMIC_DEC  */
  YYSYMBOL_T_OP_ATOMIC_CMPXCHG = 202,      /* T_OP_ATOMIC_CMPXCHG  */
  YYSYMBOL_T_OP_ATOMIC_MIN = 203,          /* T_OP_ATOMIC_MIN  */
  YYSYMBOL_T_OP_ATOMIC_MAX = 204,          /* T_OP_ATOMIC_MAX  */
  YYSYMBOL_T_OP_ATOMIC_AND = 205,          /* T_OP_ATOMIC_AND  */
  YYSYMBOL_T_OP_ATOMIC_OR = 206,           /* T_OP_ATOMIC_OR  */
  YYSYMBOL_T_OP_ATOMIC_XOR = 207,          /* T_OP_ATOMIC_XOR  */
  YYSYMBOL_T_OP_RESINFO_B = 208,           /* T_OP_RESINFO_B  */
  YYSYMBOL_T_OP_LDIB_B = 209,              /* T_OP_LDIB_B  */
  YYSYMBOL_T_OP_STIB_B = 210,              /* T_OP_STIB_B  */
  YYSYMBOL_T_OP_ATOMIC_B_ADD = 211,        /* T_OP_ATOMIC_B_ADD  */
  YYSYMBOL_T_OP_ATOMIC_B_SUB = 212,        /* T_OP_ATOMIC_B_SUB  */
  YYSYMBOL_T_OP_ATOMIC_B_XCHG = 213,       /* T_OP_ATOMIC_B_XCHG  */
  YYSYMBOL_T_OP_ATOMIC_B_INC = 214,        /* T_OP_ATOMIC_B_INC  */
  YYSYMBOL_T_OP_ATOMIC_B_DEC = 215,        /* T_OP_ATOMIC_B_DEC  */
  YYSYMBOL_T_OP_ATOMIC_B_CMPXCHG = 216,    /* T_OP_ATOMIC_B_CMPXCHG  */
  YYSYMBOL_T_OP_ATOMIC_B_MIN = 217,        /* T_OP_ATOMIC_B_MIN  */
  YYSYMBOL_T_OP_ATOMIC_B_MAX = 218,        /* T_OP_ATOMIC_B_MAX  */
  YYSYMBOL_T_OP_ATOMIC_B_AND = 219,        /* T_OP_ATOMIC_B_AND  */
  YYSYMBOL_T_OP_ATOMIC_B_OR = 220,         /* T_OP_ATOMIC_B_OR  */
  YYSYMBOL_T_OP_ATOMIC_B_XOR = 221,        /* T_OP_ATOMIC_B_XOR  */
  YYSYMBOL_T_OP_LDGB = 222,                /* T_OP_LDGB  */
  YYSYMBOL_T_OP_STGB = 223,                /* T_OP_STGB  */
  YYSYMBOL_T_OP_STIB = 224,                /* T_OP_STIB  */
  YYSYMBOL_T_OP_LDC = 225,                 /* T_OP_LDC  */
  YYSYMBOL_T_OP_LDLV = 226,                /* T_OP_LDLV  */
  YYSYMBOL_T_OP_GETSPID = 227,             /* T_OP_GETSPID  */
  YYSYMBOL_T_OP_GETWID = 228,              /* T_OP_GETWID  */
  YYSYMBOL_T_OP_BAR = 229,                 /* T_OP_BAR  */
  YYSYMBOL_T_OP_FENCE = 230,               /* T_OP_FENCE  */
  YYSYMBOL_T_TYPE_F16 = 231,               /* T_TYPE_F16  */
  YYSYMBOL_T_TYPE_F32 = 232,               /* T_TYPE_F32  */
  YYSYMBOL_T_TYPE_U16 = 233,               /* T_TYPE_U16  */
  YYSYMBOL_T_TYPE_U32 = 234,               /* T_TYPE_U32  */
  YYSYMBOL_T_TYPE_S16 = 235,               /* T_TYPE_S16  */
  YYSYMBOL_T_TYPE_S32 = 236,               /* T_TYPE_S32  */
  YYSYMBOL_T_TYPE_U8 = 237,                /* T_TYPE_U8  */
  YYSYMBOL_T_TYPE_S8 = 238,                /* T_TYPE_S8  */
  YYSYMBOL_T_UNTYPED = 239,                /* T_UNTYPED  */
  YYSYMBOL_T_TYPED = 240,                  /* T_TYPED  */
  YYSYMBOL_T_1D = 241,                     /* T_1D  */
  YYSYMBOL_T_2D = 242,                     /* T_2D  */
  YYSYMBOL_T_3D = 243,                     /* T_3D  */
  YYSYMBOL_T_4D = 244,                     /* T_4D  */
  YYSYMBOL_T_LT = 245,                     /* T_LT  */
  YYSYMBOL_T_LE = 246,                     /* T_LE  */
  YYSYMBOL_T_GT = 247,                     /* T_GT  */
  YYSYMBOL_T_GE = 248,                     /* T_GE  */
  YYSYMBOL_T_EQ = 249,                     /* T_EQ  */
  YYSYMBOL_T_NE = 250,                     /* T_NE  */
  YYSYMBOL_T_S2EN = 251,                   /* T_S2EN  */
  YYSYMBOL_T_SAMP = 252,                   /* T_SAMP  */
  YYSYMBOL_T_TEX = 253,                    /* T_TEX  */
  YYSYMBOL_T_BASE = 254,                   /* T_BASE  */
  YYSYMBOL_T_OFFSET = 255,                 /* T_OFFSET  */
  YYSYMBOL_T_UNIFORM = 256,                /* T_UNIFORM  */
  YYSYMBOL_T_NONUNIFORM = 257,             /* T_NONUNIFORM  */
  YYSYMBOL_T_IMM = 258,                    /* T_IMM  */
  YYSYMBOL_T_NAN = 259,                    /* T_NAN  */
  YYSYMBOL_T_INF = 260,                    /* T_INF  */
  YYSYMBOL_T_A0 = 261,                     /* T_A0  */
  YYSYMBOL_T_A1 = 262,                     /* T_A1  */
  YYSYMBOL_T_P0 = 263,                     /* T_P0  */
  YYSYMBOL_T_W = 264,                      /* T_W  */
  YYSYMBOL_T_CAT1_TYPE_TYPE = 265,         /* T_CAT1_TYPE_TYPE  */
  YYSYMBOL_266_ = 266,                     /* '-'  */
  YYSYMBOL_267_ = 267,                     /* ','  */
  YYSYMBOL_268_ = 268,                     /* '('  */
  YYSYMBOL_269_ = 269,                     /* ')'  */
  YYSYMBOL_270_ = 270,                     /* '='  */
  YYSYMBOL_271_ = 271,                     /* ':'  */
  YYSYMBOL_272_ = 272,                     /* '!'  */
  YYSYMBOL_273_ = 273,                     /* '#'  */
  YYSYMBOL_274_ = 274,                     /* '.'  */
  YYSYMBOL_275_a_ = 275,                   /* 'a'  */
  YYSYMBOL_276_o_ = 276,                   /* 'o'  */
  YYSYMBOL_277_p_ = 277,                   /* 'p'  */
  YYSYMBOL_278_s_ = 278,                   /* 's'  */
  YYSYMBOL_279_ = 279,                     /* '+'  */
  YYSYMBOL_280_g_ = 280,                   /* 'g'  */
  YYSYMBOL_281_ = 281,                     /* '['  */
  YYSYMBOL_282_ = 282,                     /* ']'  */
  YYSYMBOL_283_l_ = 283,                   /* 'l'  */
  YYSYMBOL_284_w_ = 284,                   /* 'w'  */
  YYSYMBOL_285_r_ = 285,                   /* 'r'  */
  YYSYMBOL_286_ = 286,                     /* '<'  */
  YYSYMBOL_287_ = 287,                     /* '>'  */
  YYSYMBOL_288_c_ = 288,                   /* 'c'  */
  YYSYMBOL_289_h_ = 289,                   /* 'h'  */
  YYSYMBOL_YYACCEPT = 290,                 /* $accept  */
  YYSYMBOL_shader = 291,                   /* shader  */
  YYSYMBOL_292_1 = 292,                    /* $@1  */
  YYSYMBOL_headers = 293,                  /* headers  */
  YYSYMBOL_header = 294,                   /* header  */
  YYSYMBOL_const_val = 295,                /* const_val  */
  YYSYMBOL_localsize_header = 296,         /* localsize_header  */
  YYSYMBOL_const_header = 297,             /* const_header  */
  YYSYMBOL_buf_header = 298,               /* buf_header  */
  YYSYMBOL_invocationid_header = 299,      /* invocationid_header  */
  YYSYMBOL_wgid_header = 300,              /* wgid_header  */
  YYSYMBOL_numwg_header = 301,             /* numwg_header  */
  YYSYMBOL_branchstack_header = 302,       /* branchstack_header  */
  YYSYMBOL_in_header = 303,                /* in_header  */
  YYSYMBOL_out_header = 304,               /* out_header  */
  YYSYMBOL_tex_header = 305,               /* tex_header  */
  YYSYMBOL_iflag = 306,                    /* iflag  */
  YYSYMBOL_iflags = 307,                   /* iflags  */
  YYSYMBOL_instrs = 308,                   /* instrs  */
  YYSYMBOL_instr = 309,                    /* instr  */
  YYSYMBOL_label = 310,                    /* label  */
  YYSYMBOL_cat0_src1 = 311,                /* cat0_src1  */
  YYSYMBOL_cat0_src2 = 312,                /* cat0_src2  */
  YYSYMBOL_cat0_immed = 313,               /* cat0_immed  */
  YYSYMBOL_cat0_instr = 314,               /* cat0_instr  */
  YYSYMBOL_315_2 = 315,                    /* $@2  */
  YYSYMBOL_316_3 = 316,                    /* $@3  */
  YYSYMBOL_317_4 = 317,                    /* $@4  */
  YYSYMBOL_318_5 = 318,                    /* $@5  */
  YYSYMBOL_319_6 = 319,                    /* $@6  */
  YYSYMBOL_320_7 = 320,                    /* $@7  */
  YYSYMBOL_321_8 = 321,                    /* $@8  */
  YYSYMBOL_322_9 = 322,                    /* $@9  */
  YYSYMBOL_323_10 = 323,                   /* $@10  */
  YYSYMBOL_324_11 = 324,                   /* $@11  */
  YYSYMBOL_325_12 = 325,                   /* $@12  */
  YYSYMBOL_326_13 = 326,                   /* $@13  */
  YYSYMBOL_327_14 = 327,                   /* $@14  */
  YYSYMBOL_328_15 = 328,                   /* $@15  */
  YYSYMBOL_329_16 = 329,                   /* $@16  */
  YYSYMBOL_cat1_opc = 330,                 /* cat1_opc  */
  YYSYMBOL_cat1_src = 331,                 /* cat1_src  */
  YYSYMBOL_cat1_movmsk = 332,              /* cat1_movmsk  */
  YYSYMBOL_333_17 = 333,                   /* $@17  */
  YYSYMBOL_cat1_mova1 = 334,               /* cat1_mova1  */
  YYSYMBOL_335_18 = 335,                   /* $@18  */
  YYSYMBOL_cat1_mova = 336,                /* cat1_mova  */
  YYSYMBOL_337_19 = 337,                   /* $@19  */
  YYSYMBOL_cat1_instr = 338,               /* cat1_instr  */
  YYSYMBOL_cat2_opc_1src = 339,            /* cat2_opc_1src  */
  YYSYMBOL_cat2_opc_2src_cnd = 340,        /* cat2_opc_2src_cnd  */
  YYSYMBOL_cat2_opc_2src = 341,            /* cat2_opc_2src  */
  YYSYMBOL_cond = 342,                     /* cond  */
  YYSYMBOL_cat2_instr = 343,               /* cat2_instr  */
  YYSYMBOL_cat3_opc = 344,                 /* cat3_opc  */
  YYSYMBOL_cat3_instr = 345,               /* cat3_instr  */
  YYSYMBOL_cat4_opc = 346,                 /* cat4_opc  */
  YYSYMBOL_cat4_instr = 347,               /* cat4_instr  */
  YYSYMBOL_cat5_opc_dsxypp = 348,          /* cat5_opc_dsxypp  */
  YYSYMBOL_cat5_opc = 349,                 /* cat5_opc  */
  YYSYMBOL_cat5_flag = 350,                /* cat5_flag  */
  YYSYMBOL_cat5_flags = 351,               /* cat5_flags  */
  YYSYMBOL_cat5_samp = 352,                /* cat5_samp  */
  YYSYMBOL_cat5_tex = 353,                 /* cat5_tex  */
  YYSYMBOL_cat5_type = 354,                /* cat5_type  */
  YYSYMBOL_cat5_a1 = 355,                  /* cat5_a1  */
  YYSYMBOL_cat5_instr = 356,               /* cat5_instr  */
  YYSYMBOL_cat6_typed = 357,               /* cat6_typed  */
  YYSYMBOL_cat6_dim = 358,                 /* cat6_dim  */
  YYSYMBOL_cat6_type = 359,                /* cat6_type  */
  YYSYMBOL_cat6_offset = 360,              /* cat6_offset  */
  YYSYMBOL_cat6_dst_offset = 361,          /* cat6_dst_offset  */
  YYSYMBOL_cat6_immed = 362,               /* cat6_immed  */
  YYSYMBOL_cat6_load = 363,                /* cat6_load  */
  YYSYMBOL_364_20 = 364,                   /* $@20  */
  YYSYMBOL_365_21 = 365,                   /* $@21  */
  YYSYMBOL_366_22 = 366,                   /* $@22  */
  YYSYMBOL_367_23 = 367,                   /* $@23  */
  YYSYMBOL_368_24 = 368,                   /* $@24  */
  YYSYMBOL_369_25 = 369,                   /* $@25  */
  YYSYMBOL_cat6_store = 370,               /* cat6_store  */
  YYSYMBOL_371_26 = 371,                   /* $@26  */
  YYSYMBOL_372_27 = 372,                   /* $@27  */
  YYSYMBOL_373_28 = 373,                   /* $@28  */
  YYSYMBOL_374_29 = 374,                   /* $@29  */
  YYSYMBOL_cat6_storeib = 375,             /* cat6_storeib  */
  YYSYMBOL_376_30 = 376,                   /* $@30  */
  YYSYMBOL_cat6_prefetch = 377,            /* cat6_prefetch  */
  YYSYMBOL_378_31 = 378,                   /* $@31  */
  YYSYMBOL_cat6_atomic_opc = 379,          /* cat6_atomic_opc  */
  YYSYMBOL_cat6_atomic_g = 380,            /* cat6_atomic_g  */
  YYSYMBOL_cat6_atomic_l = 381,            /* cat6_atomic_l  */
  YYSYMBOL_cat6_atomic = 382,              /* cat6_atomic  */
  YYSYMBOL_cat6_ibo_opc_1src = 383,        /* cat6_ibo_opc_1src  */
  YYSYMBOL_cat6_ibo_opc_ldgb = 384,        /* cat6_ibo_opc_ldgb  */
  YYSYMBOL_cat6_ibo_opc_stgb = 385,        /* cat6_ibo_opc_stgb  */
  YYSYMBOL_cat6_ibo = 386,                 /* cat6_ibo  */
  YYSYMBOL_387_32 = 387,                   /* $@32  */
  YYSYMBOL_cat6_id_opc = 388,              /* cat6_id_opc  */
  YYSYMBOL_cat6_id = 389,                  /* cat6_id  */
  YYSYMBOL_cat6_bindless_base = 390,       /* cat6_bindless_base  */
  YYSYMBOL_cat6_bindless_mode = 391,       /* cat6_bindless_mode  */
  YYSYMBOL_cat6_reg_or_immed = 392,        /* cat6_reg_or_immed  */
  YYSYMBOL_cat6_bindless_ibo_opc_1src = 393, /* cat6_bindless_ibo_opc_1src  */
  YYSYMBOL_cat6_bindless_ibo_opc_2src = 394, /* cat6_bindless_ibo_opc_2src  */
  YYSYMBOL_cat6_bindless_ibo = 395,        /* cat6_bindless_ibo  */
  YYSYMBOL_cat6_bindless_ldc_opc = 396,    /* cat6_bindless_ldc_opc  */
  YYSYMBOL_cat6_bindless_ldc = 397,        /* cat6_bindless_ldc  */
  YYSYMBOL_cat6_todo = 398,                /* cat6_todo  */
  YYSYMBOL_cat6_instr = 399,               /* cat6_instr  */
  YYSYMBOL_cat7_scope = 400,               /* cat7_scope  */
  YYSYMBOL_cat7_scopes = 401,              /* cat7_scopes  */
  YYSYMBOL_cat7_barrier = 402,             /* cat7_barrier  */
  YYSYMBOL_403_33 = 403,                   /* $@33  */
  YYSYMBOL_404_34 = 404,                   /* $@34  */
  YYSYMBOL_cat7_instr = 405,               /* cat7_instr  */
  YYSYMBOL_reg = 406,                      /* reg  */
  YYSYMBOL_const = 407,                    /* const  */
  YYSYMBOL_dst_reg_flag = 408,             /* dst_reg_flag  */
  YYSYMBOL_dst_reg_flags = 409,            /* dst_reg_flags  */
  YYSYMBOL_dst_reg = 410,                  /* dst_reg  */
  YYSYMBOL_src_reg_flag = 411,             /* src_reg_flag  */
  YYSYMBOL_src_reg_flags = 412,            /* src_reg_flags  */
  YYSYMBOL_src_reg = 413,                  /* src_reg  */
  YYSYMBOL_src_const = 414,                /* src_const  */
  YYSYMBOL_src_reg_or_const = 415,         /* src_reg_or_const  */
  YYSYMBOL_src_reg_or_const_or_rel = 416,  /* src_reg_or_const_or_rel  */
  YYSYMBOL_src_reg_or_const_or_rel_or_imm = 417, /* src_reg_or_const_or_rel_or_imm  */
  YYSYMBOL_offset = 418,                   /* offset  */
  YYSYMBOL_relative_gpr = 419,             /* relative_gpr  */
  YYSYMBOL_relative_const = 420,           /* relative_const  */
  YYSYMBOL_relative = 421,                 /* relative  */
  YYSYMBOL_immediate_cat1 = 422,           /* immediate_cat1  */
  YYSYMBOL_immediate = 423,                /* immediate  */
  YYSYMBOL_flut_immed = 424,               /* flut_immed  */
  YYSYMBOL_integer = 425,                  /* integer  */
  YYSYMBOL_float = 426,                    /* float  */
  YYSYMBOL_type = 427                      /* type  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;


/* Second part of user prologue.  */
#line 293 "../src/freedreno/ir3/ir3_parser.y"

#if YYDEBUG
static void print_token(FILE *file, int type, YYSTYPE value)
{
	fprintf(file, "\ntype: %d\n", type);
}

#define YYPRINT(file, type, value) print_token(file, type, value)
#endif

#line 798 "src/freedreno/ir3/ir3_parser.c"


#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1013

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  290
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  138
/* YYNRULES -- Number of rules.  */
#define YYNRULES  443
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  868

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   520


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   272,     2,   273,     2,     2,     2,     2,
     268,   269,     2,   279,   267,   266,   274,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   271,     2,
     286,   270,   287,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   281,     2,   282,     2,     2,     2,   275,     2,   288,
       2,     2,     2,   280,   289,     2,     2,     2,   283,     2,
       2,   276,   277,     2,   285,   278,     2,     2,     2,   284,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   622,   622,   622,   624,   625,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   638,   639,   640,   641,
     643,   649,   653,   659,   665,   672,   680,   683,   685,   687,
     694,   695,   696,   697,   698,   699,   700,   702,   703,   705,
     706,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     718,   720,   721,   723,   724,   726,   727,   729,   730,   730,
     731,   731,   732,   732,   733,   733,   734,   734,   735,   735,
     736,   736,   737,   737,   738,   738,   739,   740,   740,   741,
     742,   743,   744,   745,   746,   747,   747,   748,   749,   750,
     751,   752,   752,   753,   754,   754,   755,   756,   756,   757,
     757,   758,   760,   763,   767,   768,   770,   770,   778,   778,
     785,   785,   793,   794,   795,   796,   797,   799,   800,   801,
     802,   803,   804,   805,   806,   807,   808,   809,   810,   811,
     812,   814,   815,   816,   817,   818,   819,   821,   822,   823,
     824,   825,   826,   827,   828,   829,   830,   831,   832,   833,
     834,   835,   836,   837,   838,   839,   840,   841,   842,   843,
     844,   845,   846,   848,   849,   850,   851,   852,   853,   855,
     856,   857,   859,   860,   861,   862,   863,   864,   865,   866,
     867,   868,   869,   870,   871,   872,   873,   874,   876,   878,
     879,   880,   881,   882,   883,   884,   885,   886,   887,   889,
     891,   892,   894,   895,   896,   897,   898,   899,   900,   901,
     902,   903,   904,   905,   906,   907,   908,   909,   910,   911,
     912,   913,   914,   915,   916,   917,   918,   919,   921,   922,
     923,   924,   925,   926,   927,   928,   929,   930,   932,   933,
     934,   935,   937,   938,   939,   940,   941,   942,   943,   944,
     945,   946,   947,   948,   949,   950,   951,   953,   954,   956,
     957,   958,   959,   961,   962,   963,   964,   965,   967,   969,
     969,   970,   970,   971,   971,   972,   972,   973,   973,   973,
     980,   980,   989,   989,   990,   990,   991,   991,   993,   993,
     995,   995,   997,   998,   999,  1000,  1001,  1002,  1003,  1004,
    1005,  1006,  1007,  1009,  1013,  1015,  1016,  1018,  1020,  1021,
    1023,  1024,  1025,  1025,  1028,  1029,  1031,  1033,  1034,  1036,
    1037,  1038,  1040,  1041,  1043,  1045,  1046,  1047,  1048,  1049,
    1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,  1059,  1060,
    1071,  1073,  1080,  1081,  1082,  1084,  1085,  1086,  1087,  1088,
    1089,  1090,  1091,  1092,  1093,  1095,  1096,  1097,  1098,  1100,
    1101,  1103,  1103,  1104,  1104,  1106,  1108,  1109,  1110,  1111,
    1113,  1115,  1116,  1117,  1118,  1120,  1121,  1124,  1125,  1127,
    1128,  1129,  1130,  1132,  1133,  1135,  1136,  1138,  1139,  1141,
    1142,  1144,  1145,  1146,  1148,  1149,  1150,  1152,  1153,  1154,
    1156,  1157,  1159,  1160,  1162,  1163,  1169,  1170,  1171,  1172,
    1173,  1174,  1175,  1177,  1178,  1179,  1180,  1181,  1184,  1185,
    1186,  1187,  1188,  1189,  1190,  1191,  1192,  1193,  1194,  1195,
    1197,  1198,  1199,  1200,  1202,  1203,  1205,  1206,  1207,  1208,
    1209,  1210,  1211,  1212
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "T_INT", "T_HEX",
  "T_FLOAT", "T_IDENTIFIER", "T_REGISTER", "T_CONSTANT", "T_A_LOCALSIZE",
  "T_A_CONST", "T_A_BUF", "T_A_INVOCATIONID", "T_A_WGID", "T_A_NUMWG",
  "T_A_BRANCHSTACK", "T_A_IN", "T_A_OUT", "T_A_TEX", "T_ABSNEG", "T_NEG",
  "T_ABS", "T_R", "T_HR", "T_HC", "T_EVEN", "T_POS_INFINITY", "T_EI",
  "T_WRMASK", "T_FLUT_0_0", "T_FLUT_0_5", "T_FLUT_1_0", "T_FLUT_2_0",
  "T_FLUT_E", "T_FLUT_PI", "T_FLUT_INV_PI", "T_FLUT_INV_LOG2_E",
  "T_FLUT_LOG2_E", "T_FLUT_INV_LOG2_10", "T_FLUT_LOG2_10", "T_FLUT_4_0",
  "T_SY", "T_SS", "T_JP", "T_SAT", "T_RPT", "T_UL", "T_NOP", "T_OP_NOP",
  "T_OP_BR", "T_OP_BRAO", "T_OP_BRAA", "T_OP_BRAC", "T_OP_BANY",
  "T_OP_BALL", "T_OP_BRAX", "T_OP_JUMP", "T_OP_CALL", "T_OP_RET",
  "T_OP_KILL", "T_OP_END", "T_OP_EMIT", "T_OP_CUT", "T_OP_CHMASK",
  "T_OP_CHSH", "T_OP_FLOW_REV", "T_OP_BKT", "T_OP_STKS", "T_OP_STKR",
  "T_OP_XSET", "T_OP_XCLR", "T_OP_GETONE", "T_OP_DBG", "T_OP_SHPS",
  "T_OP_SHPE", "T_OP_PREDT", "T_OP_PREDF", "T_OP_PREDE", "T_OP_MOVMSK",
  "T_OP_MOVA1", "T_OP_MOVA", "T_OP_MOV", "T_OP_COV", "T_OP_ADD_F",
  "T_OP_MIN_F", "T_OP_MAX_F", "T_OP_MUL_F", "T_OP_SIGN_F", "T_OP_CMPS_F",
  "T_OP_ABSNEG_F", "T_OP_CMPV_F", "T_OP_FLOOR_F", "T_OP_CEIL_F",
  "T_OP_RNDNE_F", "T_OP_RNDAZ_F", "T_OP_TRUNC_F", "T_OP_ADD_U",
  "T_OP_ADD_S", "T_OP_SUB_U", "T_OP_SUB_S", "T_OP_CMPS_U", "T_OP_CMPS_S",
  "T_OP_MIN_U", "T_OP_MIN_S", "T_OP_MAX_U", "T_OP_MAX_S", "T_OP_ABSNEG_S",
  "T_OP_AND_B", "T_OP_OR_B", "T_OP_NOT_B", "T_OP_XOR_B", "T_OP_CMPV_U",
  "T_OP_CMPV_S", "T_OP_MUL_U24", "T_OP_MUL_S24", "T_OP_MULL_U",
  "T_OP_BFREV_B", "T_OP_CLZ_S", "T_OP_CLZ_B", "T_OP_SHL_B", "T_OP_SHR_B",
  "T_OP_ASHR_B", "T_OP_BARY_F", "T_OP_MGEN_B", "T_OP_GETBIT_B",
  "T_OP_SETRM", "T_OP_CBITS_B", "T_OP_SHB", "T_OP_MSAD", "T_OP_MAD_U16",
  "T_OP_MADSH_U16", "T_OP_MAD_S16", "T_OP_MADSH_M16", "T_OP_MAD_U24",
  "T_OP_MAD_S24", "T_OP_MAD_F16", "T_OP_MAD_F32", "T_OP_SEL_B16",
  "T_OP_SEL_B32", "T_OP_SEL_S16", "T_OP_SEL_S32", "T_OP_SEL_F16",
  "T_OP_SEL_F32", "T_OP_SAD_S16", "T_OP_SAD_S32", "T_OP_RCP", "T_OP_RSQ",
  "T_OP_LOG2", "T_OP_EXP2", "T_OP_SIN", "T_OP_COS", "T_OP_SQRT",
  "T_OP_HRSQ", "T_OP_HLOG2", "T_OP_HEXP2", "T_OP_ISAM", "T_OP_ISAML",
  "T_OP_ISAMM", "T_OP_SAM", "T_OP_SAMB", "T_OP_SAML", "T_OP_SAMGQ",
  "T_OP_GETLOD", "T_OP_CONV", "T_OP_CONVM", "T_OP_GETSIZE", "T_OP_GETBUF",
  "T_OP_GETPOS", "T_OP_GETINFO", "T_OP_DSX", "T_OP_DSY", "T_OP_GATHER4R",
  "T_OP_GATHER4G", "T_OP_GATHER4B", "T_OP_GATHER4A", "T_OP_SAMGP0",
  "T_OP_SAMGP1", "T_OP_SAMGP2", "T_OP_SAMGP3", "T_OP_DSXPP_1",
  "T_OP_DSYPP_1", "T_OP_RGETPOS", "T_OP_RGETINFO", "T_OP_LDG", "T_OP_LDL",
  "T_OP_LDP", "T_OP_STG", "T_OP_STL", "T_OP_STP", "T_OP_LDIB", "T_OP_G2L",
  "T_OP_L2G", "T_OP_PREFETCH", "T_OP_LDLW", "T_OP_STLW", "T_OP_RESFMT",
  "T_OP_RESINFO", "T_OP_ATOMIC_ADD", "T_OP_ATOMIC_SUB", "T_OP_ATOMIC_XCHG",
  "T_OP_ATOMIC_INC", "T_OP_ATOMIC_DEC", "T_OP_ATOMIC_CMPXCHG",
  "T_OP_ATOMIC_MIN", "T_OP_ATOMIC_MAX", "T_OP_ATOMIC_AND",
  "T_OP_ATOMIC_OR", "T_OP_ATOMIC_XOR", "T_OP_RESINFO_B", "T_OP_LDIB_B",
  "T_OP_STIB_B", "T_OP_ATOMIC_B_ADD", "T_OP_ATOMIC_B_SUB",
  "T_OP_ATOMIC_B_XCHG", "T_OP_ATOMIC_B_INC", "T_OP_ATOMIC_B_DEC",
  "T_OP_ATOMIC_B_CMPXCHG", "T_OP_ATOMIC_B_MIN", "T_OP_ATOMIC_B_MAX",
  "T_OP_ATOMIC_B_AND", "T_OP_ATOMIC_B_OR", "T_OP_ATOMIC_B_XOR",
  "T_OP_LDGB", "T_OP_STGB", "T_OP_STIB", "T_OP_LDC", "T_OP_LDLV",
  "T_OP_GETSPID", "T_OP_GETWID", "T_OP_BAR", "T_OP_FENCE", "T_TYPE_F16",
  "T_TYPE_F32", "T_TYPE_U16", "T_TYPE_U32", "T_TYPE_S16", "T_TYPE_S32",
  "T_TYPE_U8", "T_TYPE_S8", "T_UNTYPED", "T_TYPED", "T_1D", "T_2D", "T_3D",
  "T_4D", "T_LT", "T_LE", "T_GT", "T_GE", "T_EQ", "T_NE", "T_S2EN",
  "T_SAMP", "T_TEX", "T_BASE", "T_OFFSET", "T_UNIFORM", "T_NONUNIFORM",
  "T_IMM", "T_NAN", "T_INF", "T_A0", "T_A1", "T_P0", "T_W",
  "T_CAT1_TYPE_TYPE", "'-'", "','", "'('", "')'", "'='", "':'", "'!'",
  "'#'", "'.'", "'a'", "'o'", "'p'", "'s'", "'+'", "'g'", "'['", "']'",
  "'l'", "'w'", "'r'", "'<'", "'>'", "'c'", "'h'", "$accept", "shader",
  "$@1", "headers", "header", "const_val", "localsize_header",
  "const_header", "buf_header", "invocationid_header", "wgid_header",
  "numwg_header", "branchstack_header", "in_header", "out_header",
  "tex_header", "iflag", "iflags", "instrs", "instr", "label", "cat0_src1",
  "cat0_src2", "cat0_immed", "cat0_instr", "$@2", "$@3", "$@4", "$@5",
  "$@6", "$@7", "$@8", "$@9", "$@10", "$@11", "$@12", "$@13", "$@14",
  "$@15", "$@16", "cat1_opc", "cat1_src", "cat1_movmsk", "$@17",
  "cat1_mova1", "$@18", "cat1_mova", "$@19", "cat1_instr", "cat2_opc_1src",
  "cat2_opc_2src_cnd", "cat2_opc_2src", "cond", "cat2_instr", "cat3_opc",
  "cat3_instr", "cat4_opc", "cat4_instr", "cat5_opc_dsxypp", "cat5_opc",
  "cat5_flag", "cat5_flags", "cat5_samp", "cat5_tex", "cat5_type",
  "cat5_a1", "cat5_instr", "cat6_typed", "cat6_dim", "cat6_type",
  "cat6_offset", "cat6_dst_offset", "cat6_immed", "cat6_load", "$@20",
  "$@21", "$@22", "$@23", "$@24", "$@25", "cat6_store", "$@26", "$@27",
  "$@28", "$@29", "cat6_storeib", "$@30", "cat6_prefetch", "$@31",
  "cat6_atomic_opc", "cat6_atomic_g", "cat6_atomic_l", "cat6_atomic",
  "cat6_ibo_opc_1src", "cat6_ibo_opc_ldgb", "cat6_ibo_opc_stgb",
  "cat6_ibo", "$@32", "cat6_id_opc", "cat6_id", "cat6_bindless_base",
  "cat6_bindless_mode", "cat6_reg_or_immed", "cat6_bindless_ibo_opc_1src",
  "cat6_bindless_ibo_opc_2src", "cat6_bindless_ibo",
  "cat6_bindless_ldc_opc", "cat6_bindless_ldc", "cat6_todo", "cat6_instr",
  "cat7_scope", "cat7_scopes", "cat7_barrier", "$@33", "$@34",
  "cat7_instr", "reg", "const", "dst_reg_flag", "dst_reg_flags", "dst_reg",
  "src_reg_flag", "src_reg_flags", "src_reg", "src_const",
  "src_reg_or_const", "src_reg_or_const_or_rel",
  "src_reg_or_const_or_rel_or_imm", "offset", "relative_gpr",
  "relative_const", "relative", "immediate_cat1", "immediate",
  "flut_immed", "integer", "float", "type", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,    45,    44,    40,    41,
      61,    58,    33,    35,    46,    97,   111,   112,   115,    43,
     103,    91,    93,   108,   119,   114,    60,    62,    99,   104
};
#endif

#define YYPACT_NINF (-671)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-41)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -671,    20,   699,  -671,    21,  -246,    21,  -220,  -208,  -186,
      21,  -178,  -162,  -142,   646,   699,  -671,  -671,  -671,  -671,
    -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,    47,
    -157,   120,  -671,   134,   141,   153,  -671,   163,   189,   195,
     -67,  -671,  -671,  -671,  -671,  -671,  -671,  -671,   201,   783,
    -671,   513,  -671,  -671,  -671,    21,   -63,   -56,   -53,   -51,
     -50,   -46,   -43,  -671,  -671,  -671,  -671,  -671,  -671,   -45,
    -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,
    -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,
    -671,  -671,  -671,  -671,  -671,   -38,   -34,    -9,   -21,   -19,
    -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,
    -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,
    -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,
    -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,
    -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,
    -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,
    -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,
    -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,
    -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,
    -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,
    -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,
    -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,
    -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,
    -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,
    -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,   148,  -671,
    -671,  -671,  -671,   158,   -18,   158,  -671,   158,  -671,   158,
    -671,   -15,   -15,  -671,  -671,  -671,  -671,  -671,   -11,  -671,
    -671,  -671,   -10,   -11,   -11,  -671,   -10,  -671,   -11,   -11,
    -671,     2,  -671,  -671,  -671,  -671,  -671,  -671,    15,    21,
    -671,  -671,  -671,   286,   287,   292,  -242,  -242,  -242,    69,
    -242,  -242,    27,    27,    27,  -242,    27,    27,    27,  -242,
    -242,    37,    38,    42,    39,    56,   -10,   -10,   -10,   -10,
     -10,   -10,    57,   -10,   -10,   -11,   -10,    53,    53,  -671,
      50,  -671,  -671,  -671,  -671,  -671,  -671,  -671,    52,  -671,
     352,    -1,    81,    82,    87,   369,    89,    92,   104,   198,
     -15,   158,    79,  -122,    93,   487,    93,    93,    93,   158,
      93,    93,   118,    21,   117,   119,   122,   116,  -671,   137,
     136,   145,   146,  -671,  -671,   149,  -671,   156,   162,    60,
    -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,
    -671,  -671,  -671,  -671,   158,   158,   158,   121,   125,   165,
     144,   158,   147,    93,   158,   176,    53,  -671,  -671,   171,
     190,  -671,  -671,   321,   321,   100,  -671,  -671,  -671,  -671,
    -671,  -671,   158,   100,   375,   100,  -671,  -671,  -671,  -671,
    -671,  -671,  -671,  -671,  -671,   183,   487,   158,  -671,  -671,
     293,   -10,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,
    -671,   158,   -10,   -10,  -671,   -10,   -10,   180,  -671,    21,
     451,   456,    69,  -671,    27,  -196,  -196,  -671,  -671,    27,
      27,    27,  -671,  -671,   158,   321,   321,   196,   210,   211,
     184,   204,   205,    -1,   215,   207,   -10,   222,  -671,  -671,
    -671,  -671,  -671,  -166,  -166,  -671,  -671,  -671,  -671,  -671,
     212,    48,   213,   225,  -671,  -671,  -671,   520,    70,  -671,
    -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,
    -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,
    -671,    69,   562,   540,  -671,  -671,  -671,  -671,  -671,   229,
     235,   238,  -671,    49,   239,   242,  -671,  -671,  -671,  -671,
     237,   245,   243,   246,   250,   251,    69,   260,   261,   275,
     282,  -671,  -671,   288,   283,   294,  -671,  -671,  -671,  -671,
    -671,  -671,   285,   279,   289,    -1,    -1,    -1,  -154,   302,
      -1,   312,   307,    69,    69,   281,   301,   342,  -671,   335,
     336,   188,   338,   351,   350,    80,  -671,  -671,  -671,  -671,
     358,    69,  -671,  -671,   100,   100,   385,    -1,  -671,  -671,
     218,    69,   353,    69,    69,    69,    69,   356,  -671,    21,
      69,    69,   633,  -671,    27,    27,   359,   360,   364,  -152,
    -152,  -152,    28,   368,  -671,   370,  -152,    69,   372,  -671,
    -671,  -671,  -671,  -166,  -671,  -671,  -671,  -671,  -671,  -166,
     388,   389,  -671,   390,   387,  -671,   155,   394,  -671,  -671,
     398,  -671,   399,   393,   383,   158,  -671,   400,   401,   -77,
     404,   407,   408,   403,  -671,  -671,    -1,    -1,    -1,    28,
     402,  -671,   414,   418,  -671,   415,    -1,   419,   405,    69,
     396,   412,  -671,  -671,  -671,   100,   375,   428,   218,  -218,
      28,   437,   425,   -77,   -77,   452,   452,   452,   158,    21,
    -671,  -671,    69,  -154,  -154,  -154,  -671,   460,   461,   462,
      69,  -154,   463,   450,   453,  -671,  -671,  -671,  -671,  -671,
     465,  -671,   466,   158,   158,   454,  -671,  -671,   457,   458,
     158,   158,   480,  -671,  -671,  -671,   471,  -671,   473,   459,
     467,   468,    -1,    -1,    -1,  -671,   469,    -1,     7,  -671,
     417,   218,   475,   476,  -671,   464,    28,   477,   481,  -671,
      28,   741,   485,   486,   488,   489,   492,   495,   496,   497,
     472,   498,  -671,  -671,  -671,   499,  -671,  -671,   490,   484,
      28,   491,    28,    28,   501,   502,     7,     7,     7,     7,
       7,     7,     7,     7,   504,     7,   428,   493,   494,   500,
     509,  -671,   510,    28,    69,  -671,  -671,  -671,  -671,  -671,
    -671,  -671,  -671,    -1,  -671,  -671,    28,    28,   511,    -1,
      28,  -671,   512,   514,   503,   505,    -1,   516,  -671,   763,
      -1,   517,   519,   521,    28,   522,   523,    -1,    -1,    -1,
     526,    69,    -1,   527,  -671,  -671,    -1,   528,  -671,    -1,
    -671,   774,   529,   530,    -1,    69,  -671,  -671
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       2,     0,     4,     1,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    37,     4,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    17,    19,    16,     0,
       0,     0,    22,     0,     0,     0,    26,     0,     0,     0,
       0,    30,    31,    32,    33,    34,    35,    36,    37,     0,
       3,    37,    49,     5,    18,     0,     0,     0,     0,     0,
       0,     0,     0,    50,    38,    57,    58,    60,    62,     0,
      66,    68,    70,    72,    74,    76,    77,    79,    80,    81,
      82,    83,    84,    85,    87,    88,    89,    90,    91,    93,
      94,    96,    97,    99,   101,     0,     0,     0,     0,     0,
     137,   138,   139,   140,   121,   131,   117,   134,   122,   123,
     124,   125,   126,   141,   142,   143,   144,   132,   133,   145,
     146,   147,   148,   118,   149,   150,   127,   151,   135,   136,
     152,   153,   154,   128,   120,   119,   155,   156,   157,   158,
     159,   160,   129,   130,   161,   162,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   200,   201,   226,   227,
     269,   273,   271,   280,   284,   282,   342,   343,   290,   275,
     286,   344,   307,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   324,   336,   337,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   308,   309,
     288,   340,   277,   314,   315,   361,   363,    41,     0,   112,
     113,   114,    42,     0,     0,     0,    43,     0,    44,     0,
      45,   236,   236,    46,   345,   346,   347,   348,     0,   305,
     306,   349,     0,     0,     0,   350,     0,   351,     0,     0,
     353,     0,   352,   354,    47,   365,    48,    39,     0,     0,
      23,    24,    25,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   359,   359,   366,
       0,   371,   372,   373,   374,   367,   368,   369,     0,   377,
     375,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    52,     0,
       0,     0,     0,   430,   432,     0,    64,     0,     0,     0,
      71,    73,    75,    78,    86,    92,    95,    98,   100,   106,
     108,   110,   102,   103,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   359,   362,   364,     0,
       0,   376,   378,     0,     0,     0,   163,   164,   165,   166,
     167,   168,     0,     0,     0,     0,   228,   233,   235,   234,
     229,   230,   231,   232,   237,     0,     0,     0,   257,   258,
       0,     0,   436,   437,   438,   439,   440,   441,   442,   443,
     263,     0,     0,     0,   316,     0,     0,     0,    20,     0,
       0,     0,     0,    51,     0,     0,     0,   431,   433,     0,
       0,     0,    56,    55,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   358,   357,
     355,   356,   360,   397,   397,   370,   379,   380,   381,   382,
       0,     0,     0,     0,   115,   385,   387,   383,     0,   389,
     390,   391,   104,   404,   405,   392,   105,   406,   116,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,     0,     0,     0,   394,   169,   396,   415,   413,     0,
       0,     0,   199,     0,     0,   256,   259,   260,   261,   262,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    59,    54,     0,     0,     0,    65,    67,    69,   107,
     109,   111,     0,     0,     0,     0,     0,     0,   397,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   434,     0,
       0,     0,     0,     0,     0,     0,   384,   386,   388,   393,
       0,     0,   417,   395,     0,     0,     0,     0,   242,   240,
       0,     0,     0,     0,     0,     0,     0,     0,   268,     0,
       0,     0,     0,    53,     0,     0,     0,     0,     0,   397,
     397,   397,     0,     0,   264,     0,   397,     0,     0,   399,
     398,   401,   400,   397,   411,   412,   435,   407,   408,   397,
       0,     0,   414,     0,     0,   171,     0,     0,   238,   239,
     254,   255,   252,     0,     0,     0,   312,     0,     0,     0,
       0,     0,     0,     0,    61,    63,     0,     0,     0,     0,
       0,   266,     0,     0,   265,     0,     0,     0,     0,     0,
       0,     0,   409,   410,   416,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   317,   317,   317,     0,     0,
      27,    28,     0,   397,   397,   397,   267,     0,     0,     0,
       0,   397,     0,     0,     0,   403,   402,   170,   188,   253,
     250,   251,   247,     0,     0,     0,   322,   323,     0,     0,
       0,     0,     0,   320,   321,   319,     0,    21,     0,     0,
       0,     0,     0,     0,     0,   291,     0,     0,     0,   278,
       0,     0,     0,     0,   310,     0,     0,     0,     0,   318,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   248,   249,   241,   245,   246,   243,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   338,     0,     0,     0,   270,   274,   272,   281,   285,
     283,   276,   287,     0,   279,   244,     0,     0,     0,     0,
       0,   341,     0,     0,     0,     0,     0,     0,   339,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   304,   311,     0,     0,   289,     0,
     313,     0,     0,     0,     0,     0,   303,    29
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -671,  -671,  -671,   782,  -671,    -6,  -671,  -671,  -671,  -671,
    -671,  -671,  -671,  -671,  -671,  -671,  -671,   750,   738,  -671,
    -671,   397,   333,  -249,  -671,  -671,  -671,  -671,  -671,  -671,
    -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,
    -671,  -380,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,
    -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,
    -671,  -245,  -670,  -618,  -671,  -671,  -671,   -84,  -126,   305,
    -555,  -431,  -168,  -671,  -671,  -671,  -671,  -671,  -671,  -671,
    -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,
    -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,
    -539,  -492,  -158,  -671,  -671,  -671,  -671,  -671,  -671,  -671,
    -671,  -314,  -671,  -671,  -671,  -671,  -326,  -500,  -671,   470,
    -250,  -671,  -396,  -441,  -671,   199,  -401,  -407,    13,   556,
    -671,  -447,  -671,  -531,   277,  -298,   216,   371
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     1,     2,    14,    15,    30,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    48,    49,    50,    51,
      52,   370,   564,   380,   247,   296,   297,   298,   469,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     248,   504,   249,   474,   250,   475,   251,   476,   252,   253,
     254,   255,   422,   256,   257,   258,   259,   260,   261,   262,
     350,   351,   660,   661,   437,   783,   263,   354,   441,   356,
     633,   680,   617,   264,   316,   318,   317,   323,   326,   781,
     265,   319,   321,   320,   324,   266,   325,   267,   322,   268,
     269,   270,   271,   272,   273,   274,   275,   702,   276,   277,
     743,   708,   735,   278,   279,   280,   281,   282,   283,   284,
     406,   407,   285,   327,   328,   286,   339,   506,   340,   341,
     342,   507,   508,   509,   510,   511,   534,   535,   634,   513,
     514,   515,   516,   536,   537,   538,   593,   450
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      32,   376,   603,   344,    36,   346,   329,   347,   598,   348,
     373,   374,   512,   512,   408,   412,   540,   352,   542,   533,
       3,   368,    31,   541,    26,    27,    28,   533,   730,   533,
     369,   373,   374,   598,   518,   329,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,    33,   288,
      54,   373,   374,   588,   381,   382,   329,   384,   385,   386,
      34,   599,   733,   373,   374,   734,   472,   562,   496,   497,
     498,   499,   373,   374,   512,   512,   563,   329,   495,   729,
     731,   473,    35,   373,   374,   588,   599,   505,   505,   505,
      37,   785,   492,   330,   500,   570,   571,   505,   505,   505,
     583,   435,   608,   373,   374,   434,    38,   329,   495,   454,
      55,   596,   583,   584,   583,   517,   517,   438,   439,   496,
     497,   498,   499,   330,   500,   632,    39,   679,    56,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,    57,   782,   786,   477,   478,   479,   607,    58,   505,
     505,   484,   467,   468,   487,   329,   598,   578,   749,   750,
     751,    59,   329,   495,   560,   329,   756,   744,   745,   662,
      60,   330,   539,   331,   332,   333,   334,   517,   517,   705,
     706,   707,   597,   331,   332,   333,   334,   545,   825,   357,
     358,   467,   468,   646,   360,   361,    61,   654,   655,   682,
     683,   551,    62,   592,    63,   687,   289,   597,   533,   533,
     656,   740,   741,   290,   607,   561,   291,   505,   292,   293,
     566,   567,   568,   294,   569,   329,   295,   780,   312,   299,
     451,   452,   453,   600,   455,   456,   311,   496,   497,   498,
     499,   403,    41,    42,    43,    44,    45,    46,    47,   629,
     630,   631,   313,   314,   636,   315,   345,   732,   618,   349,
     335,   336,   337,   353,   355,   815,   816,   817,   818,   819,
     820,   821,   822,   375,   824,   531,   362,   486,   505,   505,
     505,   597,   363,   364,   505,   639,   640,    29,   727,   335,
     336,   337,   365,   366,   375,   728,   532,   650,   367,   533,
     379,   389,   607,   653,   392,   390,   684,   589,   590,   391,
     335,   336,   337,   618,   591,   618,   618,   618,   618,   784,
     787,   393,   671,   672,   373,   374,   375,   405,   329,   495,
     597,   335,   336,   337,   640,   375,   409,   400,   410,   618,
     496,   497,   498,   499,   330,   500,   591,   436,   413,   414,
     713,   714,   715,   716,   415,   338,   423,   458,   502,   424,
     721,   335,   336,   337,   607,   607,   375,   440,   531,   505,
     505,   425,   505,   457,   736,   674,   675,   331,   332,   333,
     334,   640,   329,   495,   459,   338,   462,   460,   502,   532,
     461,   724,   329,   495,   496,   497,   498,   499,   330,   500,
     463,   480,   737,   464,   496,   497,   498,   499,   481,   335,
     336,   337,   465,   466,   748,   701,   335,   336,   337,   335,
     336,   337,   618,   470,   329,   483,   775,   776,   777,   471,
     485,   779,   493,   338,   505,   505,   496,   497,   498,   499,
     736,   426,   482,   663,   736,   665,   666,   667,   668,   427,
     543,   494,   428,   557,   556,   429,   488,   558,   746,   489,
     490,   491,   559,   572,   736,   575,   736,   736,   737,   688,
     658,   659,   737,   430,   431,   432,   433,   573,   574,   335,
     336,   337,   579,   762,   763,   576,   577,   736,   580,   582,
     767,   768,   737,   595,   737,   737,   604,   833,   587,   594,
     736,   736,   605,   837,   736,   606,   585,   586,   609,   610,
     843,   611,   612,   -40,   846,   737,   832,   613,   736,    40,
     614,   853,   854,   855,   615,   616,   858,   619,   737,   737,
     860,   620,   737,   862,   546,   547,   548,   549,   866,   496,
     497,   498,   499,   373,   374,   621,   737,   329,   495,   622,
     624,   623,   755,   857,    41,    42,    43,    44,    45,    46,
      47,   625,   627,   330,   500,   626,   628,   867,   641,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   359,   335,   336,   337,   635,   637,   375,   642,   501,
     638,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   643,   644,   645,   338,   647,   791,   502,
     503,   649,   794,   670,   416,   417,   418,   419,   420,   421,
     648,   394,   395,   396,   397,   398,   399,   652,   401,   402,
     669,   404,   809,   664,   811,   812,   335,   336,   337,   673,
     676,   677,   681,   681,   681,   678,   335,   336,   337,   681,
     685,   686,    40,   689,   695,   831,   690,   692,   693,   694,
     338,   696,   691,   502,   700,   697,   698,   699,   834,   835,
     659,   709,   838,   712,   703,   704,   710,   711,   335,   336,
     337,   659,   720,   725,   717,   723,   850,    41,    42,    43,
      44,    45,    46,    47,   371,   372,   718,   377,   378,   726,
     719,   722,   383,   747,   738,   739,   387,   388,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,   442,   443,
     444,   445,   446,   447,   448,   449,   742,   752,   753,   754,
     757,   758,   760,   761,   769,   759,   764,   765,   770,   766,
     771,   772,   788,   789,   792,   790,   550,   795,   793,   773,
     774,   778,   796,   797,   804,   798,   799,   552,   553,   800,
     554,   555,   801,   802,   803,   805,   806,   808,   813,   845,
     807,   823,   814,   810,   826,   827,   829,   830,   836,   839,
     863,   840,   828,   844,   847,   841,   848,   842,   849,   287,
     852,   581,   851,   856,   859,   861,   864,    53,    64,   565,
     865,   335,   336,   337,   343,   657,   375,   544,   531,   602,
     411,   651,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   338,     0,     0,   502,   532,
     601,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,     0,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246
};

static const yytype_int16 yycheck[] =
{
       6,   299,   533,   253,    10,   255,     7,   257,   508,   259,
       3,     4,   413,   414,   328,   341,   423,   262,   425,   415,
       0,   263,   268,   424,     3,     4,     5,   423,   698,   425,
     272,     3,     4,   533,   414,     7,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,   268,    55,
       3,     3,     4,     5,   303,   304,     7,   306,   307,   308,
     268,   508,   280,     3,     4,   283,     6,   263,    19,    20,
      21,    22,     3,     4,   475,   476,   272,     7,     8,   697,
     698,   379,   268,     3,     4,     5,   533,   413,   414,   415,
     268,   761,   406,    23,    24,   475,   476,   423,   424,   425,
     266,   351,   543,     3,     4,   350,   268,     7,     8,   359,
     267,   507,   266,   279,   266,   413,   414,   239,   240,    19,
      20,    21,    22,    23,    24,   279,   268,   279,     8,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,     7,   760,   761,   394,   395,   396,   543,     7,   475,
     476,   401,     3,     4,   404,     7,   656,   483,   713,   714,
     715,     8,     7,     8,   462,     7,   721,   706,   707,   610,
       7,    23,   422,    25,    26,    27,    28,   475,   476,   256,
     257,   258,   508,    25,    26,    27,    28,   437,   806,   273,
     274,     3,     4,     5,   278,   279,     7,   604,   605,   630,
     631,   451,     7,   501,   271,   636,   269,   533,   604,   605,
     606,   703,   704,   269,   610,   464,   269,   543,   269,   269,
     469,   470,   471,   269,   474,     7,   269,   758,   262,   274,
     356,   357,   358,   531,   360,   361,   274,    19,    20,    21,
      22,   325,    41,    42,    43,    44,    45,    46,    47,   575,
     576,   577,   261,   274,   580,   274,   274,   698,   556,   274,
     261,   262,   263,   274,   274,   796,   797,   798,   799,   800,
     801,   802,   803,   266,   805,   268,   274,   403,   604,   605,
     606,   607,   267,   289,   610,   583,   584,   266,   695,   261,
     262,   263,     6,     6,   266,   696,   289,   595,     6,   695,
     273,   264,   698,   601,   265,   267,   632,   259,   260,   267,
     261,   262,   263,   611,   266,   613,   614,   615,   616,   760,
     761,   265,   620,   621,     3,     4,   266,   274,     7,     8,
     656,   261,   262,   263,   632,   266,   286,   280,   286,   637,
      19,    20,    21,    22,    23,    24,   266,   268,   267,   267,
     676,   677,   678,   679,   267,   285,   267,   363,   288,   267,
     686,   261,   262,   263,   760,   761,   266,   274,   268,   695,
     696,   267,   698,   255,   700,   624,   625,    25,    26,    27,
      28,   679,     7,     8,   267,   285,   270,   268,   288,   289,
     268,   689,     7,     8,    19,    20,    21,    22,    23,    24,
     263,   280,   700,   267,    19,    20,    21,    22,   283,   261,
     262,   263,   267,   267,   712,   665,   261,   262,   263,   261,
     262,   263,   720,   267,     7,   281,   752,   753,   754,   267,
     283,   757,   261,   285,   760,   761,    19,    20,    21,    22,
     766,   243,   277,   611,   770,   613,   614,   615,   616,   251,
     267,   261,   254,   459,   274,   257,   280,     6,   708,   283,
     284,   285,     6,   267,   790,   281,   792,   793,   766,   637,
     252,   253,   770,   275,   276,   277,   278,   267,   267,   261,
     262,   263,   267,   733,   734,   281,   281,   813,   281,   267,
     740,   741,   790,   268,   792,   793,   267,   823,   286,   286,
     826,   827,   267,   829,   830,   267,   493,   494,   269,   267,
     836,   274,   267,     0,   840,   813,   814,   274,   844,     6,
     274,   847,   848,   849,   274,   274,   852,   267,   826,   827,
     856,   270,   830,   859,   241,   242,   243,   244,   864,    19,
      20,    21,    22,     3,     4,   270,   844,     7,     8,   267,
     267,   263,   720,   851,    41,    42,    43,    44,    45,    46,
      47,   267,   283,    23,    24,   280,   277,   865,   287,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,   276,   261,   262,   263,   283,   274,   266,   287,   268,
     283,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,   261,   269,   269,   285,   269,   766,   288,
     289,   261,   770,   619,   245,   246,   247,   248,   249,   250,
     269,   316,   317,   318,   319,   320,   321,   269,   323,   324,
     274,   326,   790,   280,   792,   793,   261,   262,   263,     6,
     281,   281,   629,   630,   631,   281,   261,   262,   263,   636,
     282,   281,     6,   281,   267,   813,   643,   269,   269,   269,
     285,   267,   649,   288,   281,   267,   267,   274,   826,   827,
     253,   267,   830,   270,   274,   274,   269,   269,   261,   262,
     263,   253,   267,   287,   282,   280,   844,    41,    42,    43,
      44,    45,    46,    47,   297,   298,   282,   300,   301,   287,
     282,   282,   305,   709,   267,   280,   309,   310,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,   231,   232,
     233,   234,   235,   236,   237,   238,   274,   267,   267,   267,
     267,   281,   267,   267,   254,   282,   282,   280,   267,   281,
     267,   282,   267,   267,   267,   281,   441,     6,   267,   282,
     282,   282,   267,   267,   282,   267,   267,   452,   453,   267,
     455,   456,   267,   267,   267,   267,   267,   283,   267,     6,
     280,   267,   270,   282,   281,   281,   267,   267,   267,   267,
       6,   267,   282,   267,   267,   282,   267,   282,   267,    51,
     267,   486,   270,   267,   267,   267,   267,    15,    48,   466,
     270,   261,   262,   263,   248,   606,   266,   436,   268,   532,
     340,   595,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   285,    -1,    -1,   288,   289,
     268,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,   291,   292,     0,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,   293,   294,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,     3,     4,     5,   266,
     295,   268,   295,   268,   268,   268,   295,   268,   268,   268,
       6,    41,    42,    43,    44,    45,    46,    47,   306,   307,
     308,   309,   310,   293,     3,   267,     8,     7,     7,     8,
       7,     7,     7,   271,   307,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   314,   330,   332,
     334,   336,   338,   339,   340,   341,   343,   344,   345,   346,
     347,   348,   349,   356,   363,   370,   375,   377,   379,   380,
     381,   382,   383,   384,   385,   386,   388,   389,   393,   394,
     395,   396,   397,   398,   399,   402,   405,   308,   295,   269,
     269,   269,   269,   269,   269,   269,   315,   316,   317,   274,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   274,   262,   261,   274,   274,   364,   366,   365,   371,
     373,   372,   378,   367,   374,   376,   368,   403,   404,     7,
      23,    25,    26,    27,    28,   261,   262,   263,   285,   406,
     408,   409,   410,   419,   410,   274,   410,   410,   410,   274,
     350,   351,   351,   274,   357,   274,   359,   357,   357,   359,
     357,   357,   274,   267,   295,     6,     6,     6,   263,   272,
     311,   311,   311,     3,     4,   266,   425,   311,   311,   273,
     313,   313,   313,   311,   313,   313,   313,   311,   311,   264,
     267,   267,   265,   265,   359,   359,   359,   359,   359,   359,
     280,   359,   359,   357,   359,   274,   400,   401,   401,   286,
     286,   409,   406,   267,   267,   267,   245,   246,   247,   248,
     249,   250,   342,   267,   267,   267,   243,   251,   254,   257,
     275,   276,   277,   278,   351,   410,   268,   354,   239,   240,
     274,   358,   231,   232,   233,   234,   235,   236,   237,   238,
     427,   358,   358,   358,   410,   358,   358,   255,   295,   267,
     268,   268,   270,   263,   267,   267,   267,     3,     4,   318,
     267,   267,     6,   425,   333,   335,   337,   410,   410,   410,
     280,   283,   277,   281,   410,   283,   358,   410,   280,   283,
     284,   285,   401,   261,   261,     8,    19,    20,    21,    22,
      24,   268,   288,   289,   331,   406,   407,   411,   412,   413,
     414,   415,   416,   419,   420,   421,   422,   425,   331,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,   268,   289,   412,   416,   417,   423,   424,   425,   410,
     417,   416,   417,   267,   427,   410,   241,   242,   243,   244,
     359,   410,   359,   359,   359,   359,   274,   295,     6,     6,
     425,   313,   263,   272,   312,   312,   313,   313,   313,   410,
     331,   331,   267,   267,   267,   281,   281,   281,   406,   267,
     281,   359,   267,   266,   279,   418,   418,   286,     5,   259,
     260,   266,   425,   426,   286,   268,   412,   406,   407,   421,
     425,   268,   424,   423,   267,   267,   267,   412,   413,   269,
     267,   274,   267,   274,   274,   274,   274,   362,   425,   267,
     270,   270,   267,   263,   267,   267,   280,   283,   277,   406,
     406,   406,   279,   360,   418,   283,   406,   274,   283,   425,
     425,   287,   287,   261,   269,   269,     5,   269,   269,   261,
     425,   426,   269,   425,   417,   417,   412,   415,   252,   253,
     352,   353,   413,   362,   280,   362,   362,   362,   362,   274,
     295,   425,   425,     6,   313,   313,   281,   281,   281,   279,
     361,   418,   361,   361,   406,   282,   281,   361,   362,   281,
     418,   418,   269,   269,   269,   267,   267,   267,   267,   274,
     281,   410,   387,   274,   274,   256,   257,   258,   391,   267,
     269,   269,   270,   406,   406,   406,   406,   282,   282,   282,
     267,   406,   282,   280,   425,   287,   287,   417,   416,   353,
     352,   353,   413,   280,   283,   392,   406,   425,   267,   280,
     391,   391,   274,   390,   390,   390,   410,   295,   425,   360,
     360,   360,   267,   267,   267,   362,   360,   267,   281,   282,
     267,   267,   410,   410,   282,   280,   281,   410,   410,   254,
     267,   267,   282,   282,   282,   406,   406,   406,   282,   406,
     423,   369,   353,   355,   413,   352,   353,   413,   267,   267,
     281,   392,   267,   267,   392,     6,   267,   267,   267,   267,
     267,   267,   267,   267,   282,   267,   267,   280,   283,   392,
     282,   392,   392,   267,   270,   423,   423,   423,   423,   423,
     423,   423,   423,   267,   423,   353,   281,   281,   282,   267,
     267,   392,   425,   406,   392,   392,   267,   406,   392,   267,
     267,   282,   282,   406,   267,     6,   406,   267,   267,   267,
     392,   270,   267,   406,   406,   406,   267,   425,   406,   267,
     406,   267,   406,     6,   267,   270,   406,   425
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int16 yyr1[] =
{
       0,   290,   292,   291,   293,   293,   294,   294,   294,   294,
     294,   294,   294,   294,   294,   294,   295,   295,   295,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   306,   306,   306,   306,   306,   306,   307,   307,   308,
     308,   309,   309,   309,   309,   309,   309,   309,   309,   309,
     310,   311,   311,   312,   312,   313,   313,   314,   315,   314,
     316,   314,   317,   314,   318,   314,   319,   314,   320,   314,
     321,   314,   322,   314,   323,   314,   314,   324,   314,   314,
     314,   314,   314,   314,   314,   325,   314,   314,   314,   314,
     314,   326,   314,   314,   327,   314,   314,   328,   314,   329,
     314,   314,   330,   330,   331,   331,   333,   332,   335,   334,
     337,   336,   338,   338,   338,   338,   338,   339,   339,   339,
     339,   339,   339,   339,   339,   339,   339,   339,   339,   339,
     339,   340,   340,   340,   340,   340,   340,   341,   341,   341,
     341,   341,   341,   341,   341,   341,   341,   341,   341,   341,
     341,   341,   341,   341,   341,   341,   341,   341,   341,   341,
     341,   341,   341,   342,   342,   342,   342,   342,   342,   343,
     343,   343,   344,   344,   344,   344,   344,   344,   344,   344,
     344,   344,   344,   344,   344,   344,   344,   344,   345,   346,
     346,   346,   346,   346,   346,   346,   346,   346,   346,   347,
     348,   348,   349,   349,   349,   349,   349,   349,   349,   349,
     349,   349,   349,   349,   349,   349,   349,   349,   349,   349,
     349,   349,   349,   349,   349,   349,   349,   349,   350,   350,
     350,   350,   350,   350,   350,   350,   351,   351,   352,   353,
     354,   355,   356,   356,   356,   356,   356,   356,   356,   356,
     356,   356,   356,   356,   356,   356,   356,   357,   357,   358,
     358,   358,   358,   359,   360,   360,   361,   361,   362,   364,
     363,   365,   363,   366,   363,   367,   363,   368,   369,   363,
     371,   370,   372,   370,   373,   370,   374,   370,   376,   375,
     378,   377,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   380,   381,   382,   382,   383,   384,   385,
     386,   386,   387,   386,   388,   388,   389,   390,   390,   391,
     391,   391,   392,   392,   393,   394,   394,   394,   394,   394,
     394,   394,   394,   394,   394,   394,   394,   394,   395,   395,
     396,   397,   398,   398,   398,   399,   399,   399,   399,   399,
     399,   399,   399,   399,   399,   400,   400,   400,   400,   401,
     401,   403,   402,   404,   402,   405,   406,   406,   406,   406,
     407,   408,   408,   408,   408,   409,   409,   410,   410,   411,
     411,   411,   411,   412,   412,   413,   413,   414,   414,   415,
     415,   416,   416,   416,   417,   417,   417,   418,   418,   418,
     419,   419,   420,   420,   421,   421,   422,   422,   422,   422,
     422,   422,   422,   423,   423,   423,   423,   423,   424,   424,
     424,   424,   424,   424,   424,   424,   424,   424,   424,   424,
     425,   425,   425,   425,   426,   426,   427,   427,   427,   427,
     427,   427,   427,   427
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     3,     0,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     1,
       6,    11,     2,     4,     4,     4,     2,    10,    10,    23,
       1,     1,     1,     1,     1,     1,     1,     0,     2,     2,
       1,     2,     2,     2,     2,     2,     2,     2,     2,     1,
       2,     2,     1,     2,     1,     2,     2,     1,     0,     5,
       0,     7,     0,     7,     0,     5,     0,     5,     0,     5,
       0,     3,     0,     3,     0,     3,     1,     0,     3,     1,
       1,     1,     1,     1,     1,     0,     3,     1,     1,     1,
       1,     0,     3,     1,     0,     3,     1,     0,     3,     0,
       3,     1,     3,     3,     1,     1,     0,     5,     0,     5,
       0,     5,     1,     1,     1,     4,     4,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     4,
       8,     6,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     8,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     4,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     2,
       2,     2,     2,     2,     2,     2,     0,     2,     1,     1,
       3,     1,     5,    10,    12,    10,    10,     8,    10,    10,
       8,     8,     6,     8,     6,     6,     4,     2,     2,     2,
       2,     2,     2,     2,     1,     2,     1,     2,     1,     0,
      12,     0,    12,     0,    12,     0,    12,     0,     0,    12,
       0,    12,     0,    12,     0,    12,     0,    12,     0,    17,
       0,     9,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,    20,    16,     1,     1,     1,     1,     1,
       9,    16,     0,    17,     1,     1,     3,     0,     2,     2,
       2,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,    11,    13,
       1,    12,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     2,     2,     2,     0,
       2,     0,     3,     0,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     1,     2,     1,
       1,     1,     1,     1,     2,     1,     2,     1,     2,     1,
       1,     1,     1,     2,     1,     2,     1,     0,     2,     2,
       5,     5,     5,     5,     1,     1,     1,     3,     3,     4,
       4,     3,     3,     1,     3,     1,     4,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     1,     2,     1,     2,     1,     1,     1,     1,
       1,     1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
# ifndef YY_LOCATION_PRINT
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* $@1: %empty  */
#line 622 "../src/freedreno/ir3/ir3_parser.y"
                   { new_shader(); }
#line 2773 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 16: /* const_val: T_FLOAT  */
#line 638 "../src/freedreno/ir3/ir3_parser.y"
                             { (yyval.unum) = fui((yyvsp[0].flt)); }
#line 2779 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 17: /* const_val: T_INT  */
#line 639 "../src/freedreno/ir3/ir3_parser.y"
                             { (yyval.unum) = (yyvsp[0].num);      }
#line 2785 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 18: /* const_val: '-' T_INT  */
#line 640 "../src/freedreno/ir3/ir3_parser.y"
                             { (yyval.unum) = -(yyvsp[0].num);     }
#line 2791 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 19: /* const_val: T_HEX  */
#line 641 "../src/freedreno/ir3/ir3_parser.y"
                             { (yyval.unum) = (yyvsp[0].unum);      }
#line 2797 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 20: /* localsize_header: T_A_LOCALSIZE const_val ',' const_val ',' const_val  */
#line 643 "../src/freedreno/ir3/ir3_parser.y"
                                                                       {
                       variant->local_size[0] = (yyvsp[-4].unum);
                       variant->local_size[1] = (yyvsp[-2].unum);
                       variant->local_size[2] = (yyvsp[0].unum);
}
#line 2807 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 21: /* const_header: T_A_CONST '(' T_CONSTANT ')' const_val ',' const_val ',' const_val ',' const_val  */
#line 649 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                    {
                       add_const((yyvsp[-8].num), (yyvsp[-6].unum), (yyvsp[-4].unum), (yyvsp[-2].unum), (yyvsp[0].unum));
}
#line 2815 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 22: /* buf_header: T_A_BUF const_val  */
#line 653 "../src/freedreno/ir3/ir3_parser.y"
                                     {
                       int idx = info->num_bufs++;
                       assert(idx < MAX_BUFS);
                       info->buf_sizes[idx] = (yyvsp[0].unum);
}
#line 2825 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 23: /* invocationid_header: T_A_INVOCATIONID '(' T_REGISTER ')'  */
#line 659 "../src/freedreno/ir3/ir3_parser.y"
                                                         {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;
                       add_sysval(reg, 0x7, SYSTEM_VALUE_LOCAL_INVOCATION_ID);
}
#line 2835 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 24: /* wgid_header: T_A_WGID '(' T_REGISTER ')'  */
#line 665 "../src/freedreno/ir3/ir3_parser.y"
                                               {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;
                       assert(reg >= regid(48, 0)); /* must be a high reg */
                       add_sysval(reg, 0x7, SYSTEM_VALUE_WORK_GROUP_ID);
}
#line 2846 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 25: /* numwg_header: T_A_NUMWG '(' T_CONSTANT ')'  */
#line 672 "../src/freedreno/ir3/ir3_parser.y"
                                                {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;
                       info->numwg = reg;
                       /* reserve space in immediates for the actual value to be plugged in later: */
                       add_const((yyvsp[-1].num), 0, 0, 0, 0);
}
#line 2858 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 26: /* branchstack_header: T_A_BRANCHSTACK const_val  */
#line 680 "../src/freedreno/ir3/ir3_parser.y"
                                              { variant->branchstack = (yyvsp[0].unum); }
#line 2864 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 27: /* in_header: T_A_IN '(' T_REGISTER ')' T_IDENTIFIER '(' T_IDENTIFIER '=' integer ')'  */
#line 683 "../src/freedreno/ir3/ir3_parser.y"
                                                                                           { }
#line 2870 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 28: /* out_header: T_A_OUT '(' T_REGISTER ')' T_IDENTIFIER '(' T_IDENTIFIER '=' integer ')'  */
#line 685 "../src/freedreno/ir3/ir3_parser.y"
                                                                                            { }
#line 2876 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 29: /* tex_header: T_A_TEX '(' T_REGISTER ')' T_IDENTIFIER '=' integer ',' T_IDENTIFIER '=' integer ',' T_IDENTIFIER '=' integer ',' T_IDENTIFIER '=' integer ',' T_IDENTIFIER '=' integer  */
#line 692 "../src/freedreno/ir3/ir3_parser.y"
                                                              { }
#line 2882 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 30: /* iflag: T_SY  */
#line 694 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_SY; }
#line 2888 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 31: /* iflag: T_SS  */
#line 695 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_SS; }
#line 2894 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 32: /* iflag: T_JP  */
#line 696 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_JP; }
#line 2900 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 33: /* iflag: T_SAT  */
#line 697 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_SAT; }
#line 2906 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 34: /* iflag: T_RPT  */
#line 698 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.repeat = (yyvsp[0].num); }
#line 2912 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 35: /* iflag: T_UL  */
#line 699 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_UL; }
#line 2918 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 36: /* iflag: T_NOP  */
#line 700 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.nop = (yyvsp[0].tok); }
#line 2924 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 46: /* instr: iflags cat5_instr  */
#line 713 "../src/freedreno/ir3/ir3_parser.y"
                                     { fixup_cat5_s2en(); }
#line 2930 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 50: /* label: T_IDENTIFIER ':'  */
#line 718 "../src/freedreno/ir3/ir3_parser.y"
                                    { new_label((yyvsp[-1].str)); }
#line 2936 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 51: /* cat0_src1: '!' T_P0  */
#line 720 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.inv1 = true; instr->cat0.comp1 = (yyvsp[0].num) >> 1; }
#line 2942 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 52: /* cat0_src1: T_P0  */
#line 721 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.comp1 = (yyvsp[0].num) >> 1; }
#line 2948 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 53: /* cat0_src2: '!' T_P0  */
#line 723 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.inv2 = true; instr->cat0.comp2 = (yyvsp[0].num) >> 1; }
#line 2954 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 54: /* cat0_src2: T_P0  */
#line 724 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.comp2 = (yyvsp[0].num) >> 1; }
#line 2960 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 55: /* cat0_immed: '#' integer  */
#line 726 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.immed = (yyvsp[0].num); }
#line 2966 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 56: /* cat0_immed: '#' T_IDENTIFIER  */
#line 727 "../src/freedreno/ir3/ir3_parser.y"
                                    { ralloc_steal(instr, (void *)(yyvsp[0].str)); instr->cat0.target_label = (yyvsp[0].str); }
#line 2972 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 57: /* cat0_instr: T_OP_NOP  */
#line 729 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_NOP); }
#line 2978 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 58: /* $@2: %empty  */
#line 730 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_PLAIN; }
#line 2984 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 60: /* $@3: %empty  */
#line 731 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_OR;    }
#line 2990 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 62: /* $@4: %empty  */
#line 732 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_AND;    }
#line 2996 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 64: /* $@5: %empty  */
#line 733 "../src/freedreno/ir3/ir3_parser.y"
                                         { new_instr(OPC_B)->cat0.brtype = BRANCH_CONST; instr->cat0.idx = (yyvsp[0].num); }
#line 3002 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 66: /* $@6: %empty  */
#line 734 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_ANY; }
#line 3008 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 68: /* $@7: %empty  */
#line 735 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_ALL; }
#line 3014 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 70: /* $@8: %empty  */
#line 736 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_X; }
#line 3020 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 72: /* $@9: %empty  */
#line 737 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_JUMP); }
#line 3026 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 74: /* $@10: %empty  */
#line 738 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_CALL); }
#line 3032 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 76: /* cat0_instr: T_OP_RET  */
#line 739 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_RET); }
#line 3038 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 77: /* $@11: %empty  */
#line 740 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_KILL); }
#line 3044 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 79: /* cat0_instr: T_OP_END  */
#line 741 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_END); }
#line 3050 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 80: /* cat0_instr: T_OP_EMIT  */
#line 742 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_EMIT); }
#line 3056 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 81: /* cat0_instr: T_OP_CUT  */
#line 743 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_CUT); }
#line 3062 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 82: /* cat0_instr: T_OP_CHMASK  */
#line 744 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_CHMASK); }
#line 3068 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 83: /* cat0_instr: T_OP_CHSH  */
#line 745 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_CHSH); }
#line 3074 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 84: /* cat0_instr: T_OP_FLOW_REV  */
#line 746 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_FLOW_REV); }
#line 3080 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 85: /* $@12: %empty  */
#line 747 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_BKT); }
#line 3086 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 87: /* cat0_instr: T_OP_STKS  */
#line 748 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_STKS); }
#line 3092 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 88: /* cat0_instr: T_OP_STKR  */
#line 749 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_STKR); }
#line 3098 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 89: /* cat0_instr: T_OP_XSET  */
#line 750 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_XSET); }
#line 3104 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 90: /* cat0_instr: T_OP_XCLR  */
#line 751 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_XCLR); }
#line 3110 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 91: /* $@13: %empty  */
#line 752 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_GETONE); }
#line 3116 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 93: /* cat0_instr: T_OP_DBG  */
#line 753 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_DBG); }
#line 3122 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 94: /* $@14: %empty  */
#line 754 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_SHPS); }
#line 3128 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 96: /* cat0_instr: T_OP_SHPE  */
#line 755 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_SHPE); }
#line 3134 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 97: /* $@15: %empty  */
#line 756 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_PREDT); }
#line 3140 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 99: /* $@16: %empty  */
#line 757 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_PREDF); }
#line 3146 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 101: /* cat0_instr: T_OP_PREDE  */
#line 758 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_PREDE); }
#line 3152 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 102: /* cat1_opc: T_OP_MOV '.' T_CAT1_TYPE_TYPE  */
#line 760 "../src/freedreno/ir3/ir3_parser.y"
                                                 {
                       parse_type_type(new_instr(OPC_MOV), (yyvsp[0].str));
}
#line 3160 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 103: /* cat1_opc: T_OP_COV '.' T_CAT1_TYPE_TYPE  */
#line 763 "../src/freedreno/ir3/ir3_parser.y"
                                                 {
                       parse_type_type(new_instr(OPC_MOV), (yyvsp[0].str));
}
#line 3168 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 106: /* $@17: %empty  */
#line 770 "../src/freedreno/ir3/ir3_parser.y"
                                       {
                       new_instr(OPC_MOVMSK);
                       instr->cat1.src_type = TYPE_U32;
                       instr->cat1.dst_type = TYPE_U32;
                   }
#line 3178 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 107: /* cat1_movmsk: T_OP_MOVMSK '.' T_W $@17 dst_reg  */
#line 774 "../src/freedreno/ir3/ir3_parser.y"
                             {
                       instr->regs[0]->wrmask = (1 << (yyvsp[-2].num)) - 1;
                   }
#line 3186 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 108: /* $@18: %empty  */
#line 778 "../src/freedreno/ir3/ir3_parser.y"
                                       {
                       new_instr(OPC_MOV);
                       instr->cat1.src_type = TYPE_U16;
                       instr->cat1.dst_type = TYPE_U16;
                       new_reg((61 << 3) + 2, IR3_REG_HALF);
                   }
#line 3197 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 110: /* $@19: %empty  */
#line 785 "../src/freedreno/ir3/ir3_parser.y"
                                      {
                       new_instr(OPC_MOV);
                       instr->cat1.src_type = TYPE_S16;
                       instr->cat1.dst_type = TYPE_S16;
                       new_reg((61 << 3), IR3_REG_HALF);
                   }
#line 3208 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 117: /* cat2_opc_1src: T_OP_ABSNEG_F  */
#line 799 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ABSNEG_F); }
#line 3214 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 118: /* cat2_opc_1src: T_OP_ABSNEG_S  */
#line 800 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ABSNEG_S); }
#line 3220 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 119: /* cat2_opc_1src: T_OP_CLZ_B  */
#line 801 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CLZ_B); }
#line 3226 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 120: /* cat2_opc_1src: T_OP_CLZ_S  */
#line 802 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CLZ_S); }
#line 3232 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 121: /* cat2_opc_1src: T_OP_SIGN_F  */
#line 803 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SIGN_F); }
#line 3238 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 122: /* cat2_opc_1src: T_OP_FLOOR_F  */
#line 804 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_FLOOR_F); }
#line 3244 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 123: /* cat2_opc_1src: T_OP_CEIL_F  */
#line 805 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CEIL_F); }
#line 3250 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 124: /* cat2_opc_1src: T_OP_RNDNE_F  */
#line 806 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RNDNE_F); }
#line 3256 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 125: /* cat2_opc_1src: T_OP_RNDAZ_F  */
#line 807 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RNDAZ_F); }
#line 3262 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 126: /* cat2_opc_1src: T_OP_TRUNC_F  */
#line 808 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_TRUNC_F); }
#line 3268 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 127: /* cat2_opc_1src: T_OP_NOT_B  */
#line 809 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_NOT_B); }
#line 3274 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 128: /* cat2_opc_1src: T_OP_BFREV_B  */
#line 810 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_BFREV_B); }
#line 3280 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 129: /* cat2_opc_1src: T_OP_SETRM  */
#line 811 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SETRM); }
#line 3286 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 130: /* cat2_opc_1src: T_OP_CBITS_B  */
#line 812 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CBITS_B); }
#line 3292 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 131: /* cat2_opc_2src_cnd: T_OP_CMPS_F  */
#line 814 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPS_F); }
#line 3298 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 132: /* cat2_opc_2src_cnd: T_OP_CMPS_U  */
#line 815 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPS_U); }
#line 3304 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 133: /* cat2_opc_2src_cnd: T_OP_CMPS_S  */
#line 816 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPS_S); }
#line 3310 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 134: /* cat2_opc_2src_cnd: T_OP_CMPV_F  */
#line 817 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPV_F); }
#line 3316 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 135: /* cat2_opc_2src_cnd: T_OP_CMPV_U  */
#line 818 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPV_U); }
#line 3322 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 136: /* cat2_opc_2src_cnd: T_OP_CMPV_S  */
#line 819 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPV_S); }
#line 3328 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 137: /* cat2_opc_2src: T_OP_ADD_F  */
#line 821 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ADD_F); }
#line 3334 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 138: /* cat2_opc_2src: T_OP_MIN_F  */
#line 822 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MIN_F); }
#line 3340 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 139: /* cat2_opc_2src: T_OP_MAX_F  */
#line 823 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAX_F); }
#line 3346 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 140: /* cat2_opc_2src: T_OP_MUL_F  */
#line 824 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MUL_F); }
#line 3352 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 141: /* cat2_opc_2src: T_OP_ADD_U  */
#line 825 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ADD_U); }
#line 3358 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 142: /* cat2_opc_2src: T_OP_ADD_S  */
#line 826 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ADD_S); }
#line 3364 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 143: /* cat2_opc_2src: T_OP_SUB_U  */
#line 827 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SUB_U); }
#line 3370 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 144: /* cat2_opc_2src: T_OP_SUB_S  */
#line 828 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SUB_S); }
#line 3376 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 145: /* cat2_opc_2src: T_OP_MIN_U  */
#line 829 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MIN_U); }
#line 3382 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 146: /* cat2_opc_2src: T_OP_MIN_S  */
#line 830 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MIN_S); }
#line 3388 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 147: /* cat2_opc_2src: T_OP_MAX_U  */
#line 831 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAX_U); }
#line 3394 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 148: /* cat2_opc_2src: T_OP_MAX_S  */
#line 832 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAX_S); }
#line 3400 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 149: /* cat2_opc_2src: T_OP_AND_B  */
#line 833 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_AND_B); }
#line 3406 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 150: /* cat2_opc_2src: T_OP_OR_B  */
#line 834 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_OR_B); }
#line 3412 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 151: /* cat2_opc_2src: T_OP_XOR_B  */
#line 835 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_XOR_B); }
#line 3418 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 152: /* cat2_opc_2src: T_OP_MUL_U24  */
#line 836 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MUL_U24); }
#line 3424 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 153: /* cat2_opc_2src: T_OP_MUL_S24  */
#line 837 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MUL_S24); }
#line 3430 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 154: /* cat2_opc_2src: T_OP_MULL_U  */
#line 838 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MULL_U); }
#line 3436 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 155: /* cat2_opc_2src: T_OP_SHL_B  */
#line 839 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHL_B); }
#line 3442 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 156: /* cat2_opc_2src: T_OP_SHR_B  */
#line 840 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHR_B); }
#line 3448 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 157: /* cat2_opc_2src: T_OP_ASHR_B  */
#line 841 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ASHR_B); }
#line 3454 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 158: /* cat2_opc_2src: T_OP_BARY_F  */
#line 842 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_BARY_F); }
#line 3460 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 159: /* cat2_opc_2src: T_OP_MGEN_B  */
#line 843 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MGEN_B); }
#line 3466 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 160: /* cat2_opc_2src: T_OP_GETBIT_B  */
#line 844 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETBIT_B); }
#line 3472 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 161: /* cat2_opc_2src: T_OP_SHB  */
#line 845 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHB); }
#line 3478 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 162: /* cat2_opc_2src: T_OP_MSAD  */
#line 846 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MSAD); }
#line 3484 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 163: /* cond: T_LT  */
#line 848 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_LT; }
#line 3490 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 164: /* cond: T_LE  */
#line 849 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_LE; }
#line 3496 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 165: /* cond: T_GT  */
#line 850 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_GT; }
#line 3502 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 166: /* cond: T_GE  */
#line 851 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_GE; }
#line 3508 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 167: /* cond: T_EQ  */
#line 852 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_EQ; }
#line 3514 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 168: /* cond: T_NE  */
#line 853 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_NE; }
#line 3520 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 172: /* cat3_opc: T_OP_MAD_U16  */
#line 859 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_U16); }
#line 3526 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 173: /* cat3_opc: T_OP_MADSH_U16  */
#line 860 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MADSH_U16); }
#line 3532 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 174: /* cat3_opc: T_OP_MAD_S16  */
#line 861 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_S16); }
#line 3538 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 175: /* cat3_opc: T_OP_MADSH_M16  */
#line 862 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MADSH_M16); }
#line 3544 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 176: /* cat3_opc: T_OP_MAD_U24  */
#line 863 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_U24); }
#line 3550 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 177: /* cat3_opc: T_OP_MAD_S24  */
#line 864 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_S24); }
#line 3556 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 178: /* cat3_opc: T_OP_MAD_F16  */
#line 865 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_F16); }
#line 3562 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 179: /* cat3_opc: T_OP_MAD_F32  */
#line 866 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_F32); }
#line 3568 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 180: /* cat3_opc: T_OP_SEL_B16  */
#line 867 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_B16); }
#line 3574 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 181: /* cat3_opc: T_OP_SEL_B32  */
#line 868 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_B32); }
#line 3580 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 182: /* cat3_opc: T_OP_SEL_S16  */
#line 869 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_S16); }
#line 3586 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 183: /* cat3_opc: T_OP_SEL_S32  */
#line 870 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_S32); }
#line 3592 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 184: /* cat3_opc: T_OP_SEL_F16  */
#line 871 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_F16); }
#line 3598 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 185: /* cat3_opc: T_OP_SEL_F32  */
#line 872 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_F32); }
#line 3604 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 186: /* cat3_opc: T_OP_SAD_S16  */
#line 873 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAD_S16); }
#line 3610 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 187: /* cat3_opc: T_OP_SAD_S32  */
#line 874 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAD_S32); }
#line 3616 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 189: /* cat4_opc: T_OP_RCP  */
#line 878 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RCP); }
#line 3622 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 190: /* cat4_opc: T_OP_RSQ  */
#line 879 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RSQ); }
#line 3628 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 191: /* cat4_opc: T_OP_LOG2  */
#line 880 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_LOG2); }
#line 3634 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 192: /* cat4_opc: T_OP_EXP2  */
#line 881 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_EXP2); }
#line 3640 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 193: /* cat4_opc: T_OP_SIN  */
#line 882 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SIN); }
#line 3646 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 194: /* cat4_opc: T_OP_COS  */
#line 883 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_COS); }
#line 3652 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 195: /* cat4_opc: T_OP_SQRT  */
#line 884 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SQRT); }
#line 3658 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 196: /* cat4_opc: T_OP_HRSQ  */
#line 885 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_HRSQ); }
#line 3664 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 197: /* cat4_opc: T_OP_HLOG2  */
#line 886 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_HLOG2); }
#line 3670 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 198: /* cat4_opc: T_OP_HEXP2  */
#line 887 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_HEXP2); }
#line 3676 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 200: /* cat5_opc_dsxypp: T_OP_DSXPP_1  */
#line 891 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DSXPP_1)->cat5.type = TYPE_F32; }
#line 3682 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 201: /* cat5_opc_dsxypp: T_OP_DSYPP_1  */
#line 892 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DSYPP_1)->cat5.type = TYPE_F32; }
#line 3688 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 202: /* cat5_opc: T_OP_ISAM  */
#line 894 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ISAM); }
#line 3694 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 203: /* cat5_opc: T_OP_ISAML  */
#line 895 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ISAML); }
#line 3700 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 204: /* cat5_opc: T_OP_ISAMM  */
#line 896 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ISAMM); }
#line 3706 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 205: /* cat5_opc: T_OP_SAM  */
#line 897 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAM); }
#line 3712 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 206: /* cat5_opc: T_OP_SAMB  */
#line 898 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMB); }
#line 3718 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 207: /* cat5_opc: T_OP_SAML  */
#line 899 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAML); }
#line 3724 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 208: /* cat5_opc: T_OP_SAMGQ  */
#line 900 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGQ); }
#line 3730 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 209: /* cat5_opc: T_OP_GETLOD  */
#line 901 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETLOD); }
#line 3736 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 210: /* cat5_opc: T_OP_CONV  */
#line 902 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CONV); }
#line 3742 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 211: /* cat5_opc: T_OP_CONVM  */
#line 903 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CONVM); }
#line 3748 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 212: /* cat5_opc: T_OP_GETSIZE  */
#line 904 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETSIZE); }
#line 3754 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 213: /* cat5_opc: T_OP_GETBUF  */
#line 905 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETBUF); }
#line 3760 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 214: /* cat5_opc: T_OP_GETPOS  */
#line 906 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETPOS); }
#line 3766 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 215: /* cat5_opc: T_OP_GETINFO  */
#line 907 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETINFO); }
#line 3772 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 216: /* cat5_opc: T_OP_DSX  */
#line 908 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DSX); }
#line 3778 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 217: /* cat5_opc: T_OP_DSY  */
#line 909 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DSY); }
#line 3784 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 218: /* cat5_opc: T_OP_GATHER4R  */
#line 910 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GATHER4R); }
#line 3790 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 219: /* cat5_opc: T_OP_GATHER4G  */
#line 911 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GATHER4G); }
#line 3796 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 220: /* cat5_opc: T_OP_GATHER4B  */
#line 912 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GATHER4B); }
#line 3802 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 221: /* cat5_opc: T_OP_GATHER4A  */
#line 913 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GATHER4A); }
#line 3808 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 222: /* cat5_opc: T_OP_SAMGP0  */
#line 914 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGP0); }
#line 3814 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 223: /* cat5_opc: T_OP_SAMGP1  */
#line 915 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGP1); }
#line 3820 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 224: /* cat5_opc: T_OP_SAMGP2  */
#line 916 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGP2); }
#line 3826 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 225: /* cat5_opc: T_OP_SAMGP3  */
#line 917 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGP3); }
#line 3832 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 226: /* cat5_opc: T_OP_RGETPOS  */
#line 918 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RGETPOS); }
#line 3838 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 227: /* cat5_opc: T_OP_RGETINFO  */
#line 919 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RGETINFO); }
#line 3844 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 228: /* cat5_flag: '.' T_3D  */
#line 921 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_3D; }
#line 3850 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 229: /* cat5_flag: '.' 'a'  */
#line 922 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_A; }
#line 3856 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 230: /* cat5_flag: '.' 'o'  */
#line 923 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_O; }
#line 3862 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 231: /* cat5_flag: '.' 'p'  */
#line 924 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_P; }
#line 3868 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 232: /* cat5_flag: '.' 's'  */
#line 925 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_S; }
#line 3874 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 233: /* cat5_flag: '.' T_S2EN  */
#line 926 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_S2EN; }
#line 3880 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 234: /* cat5_flag: '.' T_NONUNIFORM  */
#line 927 "../src/freedreno/ir3/ir3_parser.y"
                                     { instr->flags |= IR3_INSTR_NONUNIF; }
#line 3886 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 235: /* cat5_flag: '.' T_BASE  */
#line 928 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_B; instr->cat5.tex_base = (yyvsp[0].tok); }
#line 3892 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 238: /* cat5_samp: T_SAMP  */
#line 932 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat5.samp = (yyvsp[0].tok); }
#line 3898 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 239: /* cat5_tex: T_TEX  */
#line 933 "../src/freedreno/ir3/ir3_parser.y"
                                  { if (instr->flags & IR3_INSTR_B) instr->cat5.samp |= ((yyvsp[0].tok) << 4); else instr->cat5.tex = (yyvsp[0].tok); }
#line 3904 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 240: /* cat5_type: '(' type ')'  */
#line 934 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat5.type = (yyvsp[-1].type); }
#line 3910 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 241: /* cat5_a1: src_reg  */
#line 935 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_A1EN; }
#line 3916 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 257: /* cat6_typed: '.' T_UNTYPED  */
#line 953 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat6.typed = 0; }
#line 3922 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 258: /* cat6_typed: '.' T_TYPED  */
#line 954 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat6.typed = 1; }
#line 3928 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 259: /* cat6_dim: '.' T_1D  */
#line 956 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.d = 1; }
#line 3934 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 260: /* cat6_dim: '.' T_2D  */
#line 957 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.d = 2; }
#line 3940 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 261: /* cat6_dim: '.' T_3D  */
#line 958 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.d = 3; }
#line 3946 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 262: /* cat6_dim: '.' T_4D  */
#line 959 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.d = 4; }
#line 3952 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 263: /* cat6_type: '.' type  */
#line 961 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.type = (yyvsp[0].type); }
#line 3958 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 264: /* cat6_offset: offset  */
#line 962 "../src/freedreno/ir3/ir3_parser.y"
                             { new_reg(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); }
#line 3964 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 266: /* cat6_dst_offset: offset  */
#line 964 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.dst_offset = (yyvsp[0].num); }
#line 3970 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 267: /* cat6_dst_offset: '+' reg  */
#line 965 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->flags |= IR3_INSTR_G; }
#line 3976 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 268: /* cat6_immed: integer  */
#line 967 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.iim_val = (yyvsp[0].num); }
#line 3982 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 269: /* $@20: %empty  */
#line 969 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_LDG); }
#line 3988 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 271: /* $@21: %empty  */
#line 970 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_LDP); }
#line 3994 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 273: /* $@22: %empty  */
#line 971 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_LDL); }
#line 4000 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 275: /* $@23: %empty  */
#line 972 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_LDLW); }
#line 4006 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 277: /* $@24: %empty  */
#line 973 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_LDLV); }
#line 4012 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 278: /* $@25: %empty  */
#line 973 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                {
                       new_reg(0, IR3_REG_IMMED)->iim_val = (yyvsp[-1].num);
                   }
#line 4020 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 280: /* $@26: %empty  */
#line 980 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_STG); dummy_dst(); }
#line 4026 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 281: /* cat6_store: T_OP_STG $@26 cat6_type 'g' '[' reg cat6_dst_offset ']' ',' reg ',' immediate  */
#line 980 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                                                   {
                       /* fixup src order, the offset reg is expected last currently */
                       if (instr->flags & IR3_INSTR_G) {
                           struct ir3_register *offset = instr->regs[2];
                           instr->regs[2] = instr->regs[3];
                           instr->regs[3] = instr->regs[4];
                           instr->regs[4] = offset;
                       }
                   }
#line 4040 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 282: /* $@27: %empty  */
#line 989 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_STP); dummy_dst(); }
#line 4046 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 284: /* $@28: %empty  */
#line 990 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_STL); dummy_dst(); }
#line 4052 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 286: /* $@29: %empty  */
#line 991 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_STLW); dummy_dst(); }
#line 4058 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 288: /* $@30: %empty  */
#line 993 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_STIB); dummy_dst(); }
#line 4064 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 290: /* $@31: %empty  */
#line 995 "../src/freedreno/ir3/ir3_parser.y"
                                 { new_instr(OPC_PREFETCH); new_reg(0,0); /* dummy dst */ }
#line 4070 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 292: /* cat6_atomic_opc: T_OP_ATOMIC_ADD  */
#line 997 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_ADD); }
#line 4076 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 293: /* cat6_atomic_opc: T_OP_ATOMIC_SUB  */
#line 998 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_SUB); }
#line 4082 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 294: /* cat6_atomic_opc: T_OP_ATOMIC_XCHG  */
#line 999 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_XCHG); }
#line 4088 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 295: /* cat6_atomic_opc: T_OP_ATOMIC_INC  */
#line 1000 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_INC); }
#line 4094 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 296: /* cat6_atomic_opc: T_OP_ATOMIC_DEC  */
#line 1001 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_DEC); }
#line 4100 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 297: /* cat6_atomic_opc: T_OP_ATOMIC_CMPXCHG  */
#line 1002 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_CMPXCHG); }
#line 4106 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 298: /* cat6_atomic_opc: T_OP_ATOMIC_MIN  */
#line 1003 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_MIN); }
#line 4112 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 299: /* cat6_atomic_opc: T_OP_ATOMIC_MAX  */
#line 1004 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_MAX); }
#line 4118 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 300: /* cat6_atomic_opc: T_OP_ATOMIC_AND  */
#line 1005 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_AND); }
#line 4124 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 301: /* cat6_atomic_opc: T_OP_ATOMIC_OR  */
#line 1006 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_OR); }
#line 4130 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 302: /* cat6_atomic_opc: T_OP_ATOMIC_XOR  */
#line 1007 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_XOR); }
#line 4136 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 303: /* cat6_atomic_g: cat6_atomic_opc cat6_typed cat6_dim cat6_type '.' cat6_immed '.' 'g' dst_reg ',' 'g' '[' cat6_reg_or_immed ']' ',' reg ',' reg ',' reg  */
#line 1009 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                                                                          {
                       instr->flags |= IR3_INSTR_G;
                   }
#line 4144 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 307: /* cat6_ibo_opc_1src: T_OP_RESINFO  */
#line 1018 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RESINFO); }
#line 4150 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 308: /* cat6_ibo_opc_ldgb: T_OP_LDGB  */
#line 1020 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_LDGB); }
#line 4156 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 309: /* cat6_ibo_opc_stgb: T_OP_STGB  */
#line 1021 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_STGB); }
#line 4162 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 312: /* $@32: %empty  */
#line 1025 "../src/freedreno/ir3/ir3_parser.y"
                                                                                  { dummy_dst(); }
#line 4168 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 314: /* cat6_id_opc: T_OP_GETSPID  */
#line 1028 "../src/freedreno/ir3/ir3_parser.y"
                                { new_instr(OPC_GETSPID); }
#line 4174 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 315: /* cat6_id_opc: T_OP_GETWID  */
#line 1029 "../src/freedreno/ir3/ir3_parser.y"
                                { new_instr(OPC_GETWID); }
#line 4180 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 318: /* cat6_bindless_base: '.' T_BASE  */
#line 1034 "../src/freedreno/ir3/ir3_parser.y"
                              { instr->flags |= IR3_INSTR_B; instr->cat6.base = (yyvsp[0].tok); }
#line 4186 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 321: /* cat6_bindless_mode: T_NONUNIFORM cat6_bindless_base  */
#line 1038 "../src/freedreno/ir3/ir3_parser.y"
                                                   { instr->flags |= IR3_INSTR_NONUNIF; }
#line 4192 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 323: /* cat6_reg_or_immed: integer  */
#line 1041 "../src/freedreno/ir3/ir3_parser.y"
                           { new_reg(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); }
#line 4198 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 324: /* cat6_bindless_ibo_opc_1src: T_OP_RESINFO_B  */
#line 1043 "../src/freedreno/ir3/ir3_parser.y"
                                                 { new_instr(OPC_RESINFO); }
#line 4204 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 325: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_ADD  */
#line 1045 "../src/freedreno/ir3/ir3_parser.y"
                                                     { new_instr(OPC_ATOMIC_ADD)->flags  |= IR3_INSTR_G; dummy_dst(); }
#line 4210 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 326: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_SUB  */
#line 1046 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_SUB)->flags  |= IR3_INSTR_G; dummy_dst(); }
#line 4216 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 327: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_XCHG  */
#line 1047 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_XCHG)->flags |= IR3_INSTR_G; dummy_dst(); }
#line 4222 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 328: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_INC  */
#line 1048 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_INC)->flags  |= IR3_INSTR_G; dummy_dst(); }
#line 4228 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 329: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_DEC  */
#line 1049 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_DEC)->flags  |= IR3_INSTR_G; dummy_dst(); }
#line 4234 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 330: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_CMPXCHG  */
#line 1050 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_CMPXCHG)->flags |= IR3_INSTR_G; dummy_dst(); }
#line 4240 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 331: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_MIN  */
#line 1051 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_MIN)->flags  |= IR3_INSTR_G; dummy_dst(); }
#line 4246 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 332: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_MAX  */
#line 1052 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_MAX)->flags  |= IR3_INSTR_G; dummy_dst(); }
#line 4252 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 333: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_AND  */
#line 1053 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_AND)->flags  |= IR3_INSTR_G; dummy_dst(); }
#line 4258 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 334: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_OR  */
#line 1054 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_OR)->flags   |= IR3_INSTR_G; dummy_dst(); }
#line 4264 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 335: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_XOR  */
#line 1055 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_XOR)->flags  |= IR3_INSTR_G; dummy_dst(); }
#line 4270 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 336: /* cat6_bindless_ibo_opc_2src: T_OP_LDIB_B  */
#line 1056 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_LDIB); }
#line 4276 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 337: /* cat6_bindless_ibo_opc_2src: T_OP_STIB_B  */
#line 1057 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_STIB); dummy_dst(); }
#line 4282 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 339: /* cat6_bindless_ibo: cat6_bindless_ibo_opc_2src cat6_typed cat6_dim cat6_type '.' cat6_immed '.' cat6_bindless_mode dst_reg ',' cat6_reg_or_immed ',' cat6_reg_or_immed  */
#line 1060 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                                                                                      {
                       /* TODO cleanup ir3 src order: */
                       if (is_atomic(instr->opc)) {
                           swap(instr->regs[1], instr->regs[3]);
                       } else if (instr->opc == OPC_LDIB) {
                           swap(instr->regs[1], instr->regs[2]);
                       } else if (instr->opc == OPC_STIB) {
                           swap(instr->regs[1], instr->regs[3]);
                       }
                   }
#line 4297 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 340: /* cat6_bindless_ldc_opc: T_OP_LDC  */
#line 1071 "../src/freedreno/ir3/ir3_parser.y"
                                 { new_instr(OPC_LDC); }
#line 4303 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 341: /* cat6_bindless_ldc: cat6_bindless_ldc_opc '.' T_OFFSET '.' cat6_immed '.' cat6_bindless_mode dst_reg ',' cat6_reg_or_immed ',' cat6_reg_or_immed  */
#line 1073 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                                                                {
                      instr->cat6.d = (yyvsp[-9].tok);
                      instr->cat6.type = TYPE_U32;
                      /* TODO cleanup ir3 src order: */
                      swap(instr->regs[1], instr->regs[2]);
                   }
#line 4314 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 342: /* cat6_todo: T_OP_G2L  */
#line 1080 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_G2L); }
#line 4320 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 343: /* cat6_todo: T_OP_L2G  */
#line 1081 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_L2G); }
#line 4326 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 344: /* cat6_todo: T_OP_RESFMT  */
#line 1082 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_RESFMT); }
#line 4332 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 355: /* cat7_scope: '.' 'w'  */
#line 1095 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat7.w = true; }
#line 4338 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 356: /* cat7_scope: '.' 'r'  */
#line 1096 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat7.r = true; }
#line 4344 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 357: /* cat7_scope: '.' 'l'  */
#line 1097 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat7.l = true; }
#line 4350 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 358: /* cat7_scope: '.' 'g'  */
#line 1098 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat7.g = true; }
#line 4356 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 361: /* $@33: %empty  */
#line 1103 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_BAR); }
#line 4362 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 363: /* $@34: %empty  */
#line 1104 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_FENCE); }
#line 4368 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 366: /* reg: T_REGISTER  */
#line 1108 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_reg((yyvsp[0].num), 0); }
#line 4374 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 367: /* reg: T_A0  */
#line 1109 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_reg((61 << 3), IR3_REG_HALF); }
#line 4380 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 368: /* reg: T_A1  */
#line 1110 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_reg((61 << 3) + 1, IR3_REG_HALF); }
#line 4386 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 369: /* reg: T_P0  */
#line 1111 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_reg((62 << 3) + (yyvsp[0].num), 0); }
#line 4392 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 370: /* const: T_CONSTANT  */
#line 1113 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_reg((yyvsp[0].num), IR3_REG_CONST); }
#line 4398 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 371: /* dst_reg_flag: T_EVEN  */
#line 1115 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_EVEN; }
#line 4404 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 372: /* dst_reg_flag: T_POS_INFINITY  */
#line 1116 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_POS_INF; }
#line 4410 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 373: /* dst_reg_flag: T_EI  */
#line 1117 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_EI; }
#line 4416 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 374: /* dst_reg_flag: T_WRMASK  */
#line 1118 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.wrmask = (yyvsp[0].num); }
#line 4422 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 377: /* dst_reg: reg  */
#line 1124 "../src/freedreno/ir3/ir3_parser.y"
                                       { (yyvsp[0].reg)->flags |= IR3_REG_R; }
#line 4428 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 378: /* dst_reg: dst_reg_flags reg  */
#line 1125 "../src/freedreno/ir3/ir3_parser.y"
                                       { (yyvsp[0].reg)->flags |= IR3_REG_R; }
#line 4434 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 379: /* src_reg_flag: T_ABSNEG  */
#line 1127 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_ABS|IR3_REG_NEGATE; }
#line 4440 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 380: /* src_reg_flag: T_NEG  */
#line 1128 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_NEGATE; }
#line 4446 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 381: /* src_reg_flag: T_ABS  */
#line 1129 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_ABS; }
#line 4452 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 382: /* src_reg_flag: T_R  */
#line 1130 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_R; }
#line 4458 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 397: /* offset: %empty  */
#line 1152 "../src/freedreno/ir3/ir3_parser.y"
                   { (yyval.num) = 0; }
#line 4464 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 398: /* offset: '+' integer  */
#line 1153 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = (yyvsp[0].num); }
#line 4470 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 399: /* offset: '-' integer  */
#line 1154 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = -(yyvsp[0].num); }
#line 4476 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 400: /* relative_gpr: 'r' '<' T_A0 offset '>'  */
#line 1156 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_reg(0, IR3_REG_RELATIV)->array.offset = (yyvsp[-1].num); }
#line 4482 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 401: /* relative_gpr: T_HR '<' T_A0 offset '>'  */
#line 1157 "../src/freedreno/ir3/ir3_parser.y"
                                             { new_reg(0, IR3_REG_RELATIV | IR3_REG_HALF)->array.offset = (yyvsp[-1].num); }
#line 4488 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 402: /* relative_const: 'c' '<' T_A0 offset '>'  */
#line 1159 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_reg(0, IR3_REG_RELATIV | IR3_REG_CONST)->array.offset = (yyvsp[-1].num); }
#line 4494 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 403: /* relative_const: T_HC '<' T_A0 offset '>'  */
#line 1160 "../src/freedreno/ir3/ir3_parser.y"
                                             { new_reg(0, IR3_REG_RELATIV | IR3_REG_CONST | IR3_REG_HALF)->array.offset = (yyvsp[-1].num); }
#line 4500 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 406: /* immediate_cat1: integer  */
#line 1169 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_reg(0, IR3_REG_IMMED)->iim_val = type_size(instr->cat1.src_type) < 32 ? (yyvsp[0].num) & 0xffff : (yyvsp[0].num); }
#line 4506 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 407: /* immediate_cat1: '(' integer ')'  */
#line 1170 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_reg(0, IR3_REG_IMMED)->fim_val = (yyvsp[-1].num); }
#line 4512 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 408: /* immediate_cat1: '(' float ')'  */
#line 1171 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_reg(0, IR3_REG_IMMED)->fim_val = (yyvsp[-1].flt); }
#line 4518 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 409: /* immediate_cat1: 'h' '(' integer ')'  */
#line 1172 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_reg(0, IR3_REG_IMMED | IR3_REG_HALF)->iim_val = (yyvsp[-1].num) & 0xffff; }
#line 4524 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 410: /* immediate_cat1: 'h' '(' float ')'  */
#line 1173 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_reg(0, IR3_REG_IMMED | IR3_REG_HALF)->uim_val = _mesa_float_to_half((yyvsp[-1].flt)); }
#line 4530 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 411: /* immediate_cat1: '(' T_NAN ')'  */
#line 1174 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_reg(0, IR3_REG_IMMED)->fim_val = NAN; }
#line 4536 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 412: /* immediate_cat1: '(' T_INF ')'  */
#line 1175 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_reg(0, IR3_REG_IMMED)->fim_val = INFINITY; }
#line 4542 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 413: /* immediate: integer  */
#line 1177 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_reg(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); }
#line 4548 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 414: /* immediate: '(' integer ')'  */
#line 1178 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_reg(0, IR3_REG_IMMED)->fim_val = (yyvsp[-1].num); }
#line 4554 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 415: /* immediate: flut_immed  */
#line 1179 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_reg(0, IR3_REG_IMMED)->uim_val = (yyvsp[0].num); }
#line 4560 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 416: /* immediate: 'h' '(' integer ')'  */
#line 1180 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_reg(0, IR3_REG_IMMED | IR3_REG_HALF)->iim_val = (yyvsp[-1].num); }
#line 4566 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 417: /* immediate: 'h' flut_immed  */
#line 1181 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_reg(0, IR3_REG_IMMED | IR3_REG_HALF)->uim_val = (yyvsp[0].num); }
#line 4572 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 430: /* integer: T_INT  */
#line 1197 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = (yyvsp[0].num); }
#line 4578 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 431: /* integer: '-' T_INT  */
#line 1198 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = -(yyvsp[0].num); }
#line 4584 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 432: /* integer: T_HEX  */
#line 1199 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = (yyvsp[0].unum); }
#line 4590 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 433: /* integer: '-' T_HEX  */
#line 1200 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = -(yyvsp[0].unum); }
#line 4596 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 434: /* float: T_FLOAT  */
#line 1202 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.flt) = (yyvsp[0].flt); }
#line 4602 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 435: /* float: '-' T_FLOAT  */
#line 1203 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.flt) = -(yyvsp[0].flt); }
#line 4608 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 436: /* type: T_TYPE_F16  */
#line 1205 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_F16; }
#line 4614 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 437: /* type: T_TYPE_F32  */
#line 1206 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_F32; }
#line 4620 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 438: /* type: T_TYPE_U16  */
#line 1207 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_U16; }
#line 4626 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 439: /* type: T_TYPE_U32  */
#line 1208 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_U32; }
#line 4632 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 440: /* type: T_TYPE_S16  */
#line 1209 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_S16; }
#line 4638 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 441: /* type: T_TYPE_S32  */
#line 1210 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_S32; }
#line 4644 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 442: /* type: T_TYPE_U8  */
#line 1211 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_U8;  }
#line 4650 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 443: /* type: T_TYPE_S8  */
#line 1212 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_S8;  }
#line 4656 "src/freedreno/ir3/ir3_parser.c"
    break;


#line 4660 "src/freedreno/ir3/ir3_parser.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          goto yyexhaustedlab;
      }
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if 1
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

